// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rosapi:msg/TypeDef.idl
// generated code does not contain a copyright notice

#ifndef ROSAPI__MSG__TYPE_DEF__STRUCT_HPP_
#define ROSAPI__MSG__TYPE_DEF__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

#ifndef _WIN32
# define DEPRECATED__rosapi__msg__TypeDef __attribute__((deprecated))
#else
# define DEPRECATED__rosapi__msg__TypeDef __declspec(deprecated)
#endif

namespace rosapi
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct TypeDef_
{
  using Type = TypeDef_<ContainerAllocator>;

  explicit TypeDef_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->type = "";
    }
  }

  explicit TypeDef_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : type(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->type = "";
    }
  }

  // field types and members
  using _type_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _type_type type;
  using _fieldnames_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _fieldnames_type fieldnames;
  using _fieldtypes_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _fieldtypes_type fieldtypes;
  using _fieldarraylen_type =
    std::vector<int32_t, typename ContainerAllocator::template rebind<int32_t>::other>;
  _fieldarraylen_type fieldarraylen;
  using _examples_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _examples_type examples;
  using _constnames_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _constnames_type constnames;
  using _constvalues_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _constvalues_type constvalues;

  // setters for named parameter idiom
  Type & set__type(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->type = _arg;
    return *this;
  }
  Type & set__fieldnames(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->fieldnames = _arg;
    return *this;
  }
  Type & set__fieldtypes(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->fieldtypes = _arg;
    return *this;
  }
  Type & set__fieldarraylen(
    const std::vector<int32_t, typename ContainerAllocator::template rebind<int32_t>::other> & _arg)
  {
    this->fieldarraylen = _arg;
    return *this;
  }
  Type & set__examples(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->examples = _arg;
    return *this;
  }
  Type & set__constnames(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->constnames = _arg;
    return *this;
  }
  Type & set__constvalues(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->constvalues = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rosapi::msg::TypeDef_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosapi::msg::TypeDef_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosapi::msg::TypeDef_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosapi::msg::TypeDef_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosapi::msg::TypeDef_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosapi::msg::TypeDef_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosapi::msg::TypeDef_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosapi::msg::TypeDef_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosapi::msg::TypeDef_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosapi::msg::TypeDef_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosapi__msg__TypeDef
    std::shared_ptr<rosapi::msg::TypeDef_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosapi__msg__TypeDef
    std::shared_ptr<rosapi::msg::TypeDef_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TypeDef_ & other) const
  {
    if (this->type != other.type) {
      return false;
    }
    if (this->fieldnames != other.fieldnames) {
      return false;
    }
    if (this->fieldtypes != other.fieldtypes) {
      return false;
    }
    if (this->fieldarraylen != other.fieldarraylen) {
      return false;
    }
    if (this->examples != other.examples) {
      return false;
    }
    if (this->constnames != other.constnames) {
      return false;
    }
    if (this->constvalues != other.constvalues) {
      return false;
    }
    return true;
  }
  bool operator!=(const TypeDef_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TypeDef_

// alias to use template instance with default allocator
using TypeDef =
  rosapi::msg::TypeDef_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rosapi

#endif  // ROSAPI__MSG__TYPE_DEF__STRUCT_HPP_
