#ifndef _H_9B7A40FAA79E3A602DDAE5AB57430BE1_DeleteParam__H_
#define _H_9B7A40FAA79E3A602DDAE5AB57430BE1_DeleteParam__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            struct  DeleteParam_Request_
            {
                ::DDS::String_mgr name_;
            };

            typedef DDS_DCPSStruct_var<DeleteParam_Request_> DeleteParam_Request__var;
            typedef DDS_DCPSStruct_out < DeleteParam_Request_> DeleteParam_Request__out;

            struct  DeleteParam_Response_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<DeleteParam_Response_> DeleteParam_Response__var;
            typedef DeleteParam_Response_& DeleteParam_Response__out;

            struct  Sample_DeleteParam_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::DeleteParam_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_DeleteParam_Request_> Sample_DeleteParam_Request__var;
            typedef DDS_DCPSStruct_out < Sample_DeleteParam_Request_> Sample_DeleteParam_Request__out;

            struct  Sample_DeleteParam_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::DeleteParam_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_DeleteParam_Response_> Sample_DeleteParam_Response__var;
            typedef Sample_DeleteParam_Response_& Sample_DeleteParam_Response__out;

        }

    }

}

#endif /* _H_9B7A40FAA79E3A602DDAE5AB57430BE1_DeleteParam__H_ */
