#ifndef _H_97E3568268347B8FD09F6A53BEA3831D_GetParamNames__H_
#define _H_97E3568268347B8FD09F6A53BEA3831D_GetParamNames__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetParamNames_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<GetParamNames_Request_> GetParamNames_Request__var;
            typedef GetParamNames_Request_& GetParamNames_Request__out;

            struct  GetParamNames_Response_
            {
                struct _names__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _names__seq_uniq_ > _names__seq;
                typedef DDS_DCPSUStrSeq_var< _names__seq > _names__seq_var;
                typedef DDS_DCPSUStrSeq_out< _names__seq > _names__seq_out;
                _names__seq names_;
            };

            typedef DDS_DCPSStruct_var<GetParamNames_Response_> GetParamNames_Response__var;
            typedef DDS_DCPSStruct_out < GetParamNames_Response_> GetParamNames_Response__out;

            struct  Sample_GetParamNames_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::GetParamNames_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetParamNames_Request_> Sample_GetParamNames_Request__var;
            typedef Sample_GetParamNames_Request_& Sample_GetParamNames_Request__out;

            struct  Sample_GetParamNames_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::GetParamNames_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetParamNames_Response_> Sample_GetParamNames_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetParamNames_Response_> Sample_GetParamNames_Response__out;

        }

    }

}

#endif /* _H_97E3568268347B8FD09F6A53BEA3831D_GetParamNames__H_ */
