#ifndef _H_69E7421B7060014F0D24982D81F8F92E_GetParam_DCPS_H_
#define _H_69E7421B7060014F0D24982D81F8F92E_GetParam_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetParam_.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            class GetParam_Request_TypeSupportInterface;

            typedef GetParam_Request_TypeSupportInterface * GetParam_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetParam_Request_TypeSupportInterface> GetParam_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetParam_Request_TypeSupportInterface> GetParam_Request_TypeSupportInterface_out;


            class GetParam_Request_DataWriter;

            typedef GetParam_Request_DataWriter * GetParam_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetParam_Request_DataWriter> GetParam_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetParam_Request_DataWriter> GetParam_Request_DataWriter_out;


            class GetParam_Request_DataReader;

            typedef GetParam_Request_DataReader * GetParam_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetParam_Request_DataReader> GetParam_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetParam_Request_DataReader> GetParam_Request_DataReader_out;


            class GetParam_Request_DataReaderView;

            typedef GetParam_Request_DataReaderView * GetParam_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetParam_Request_DataReaderView> GetParam_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetParam_Request_DataReaderView> GetParam_Request_DataReaderView_out;

            struct GetParam_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetParam_Request_, struct GetParam_Request_Seq_uniq_> GetParam_Request_Seq;
            typedef DDS_DCPSSequence_var < GetParam_Request_Seq> GetParam_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetParam_Request_Seq> GetParam_Request_Seq_out;

            class  GetParam_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetParam_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetParam_Request_TypeSupportInterface_var _var_type;

                static GetParam_Request_TypeSupportInterface_ptr _duplicate (GetParam_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetParam_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetParam_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetParam_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetParam_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetParam_Request_TypeSupportInterface () {};
                ~GetParam_Request_TypeSupportInterface () {};
            private:
                GetParam_Request_TypeSupportInterface (const GetParam_Request_TypeSupportInterface &);
                GetParam_Request_TypeSupportInterface & operator = (const GetParam_Request_TypeSupportInterface &);
            };

            class  GetParam_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetParam_Request_DataWriter_ptr _ptr_type;
                typedef GetParam_Request_DataWriter_var _var_type;

                static GetParam_Request_DataWriter_ptr _duplicate (GetParam_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetParam_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetParam_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetParam_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetParam_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetParam_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetParam_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetParam_Request_& instance_data) = 0;

            protected:
                GetParam_Request_DataWriter () {};
                ~GetParam_Request_DataWriter () {};
            private:
                GetParam_Request_DataWriter (const GetParam_Request_DataWriter &);
                GetParam_Request_DataWriter & operator = (const GetParam_Request_DataWriter &);
            };

            class  GetParam_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetParam_Request_DataReader_ptr _ptr_type;
                typedef GetParam_Request_DataReader_var _var_type;

                static GetParam_Request_DataReader_ptr _duplicate (GetParam_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetParam_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetParam_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetParam_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetParam_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetParam_Request_& instance) = 0;

            protected:
                GetParam_Request_DataReader () {};
                ~GetParam_Request_DataReader () {};
            private:
                GetParam_Request_DataReader (const GetParam_Request_DataReader &);
                GetParam_Request_DataReader & operator = (const GetParam_Request_DataReader &);
            };

            class  GetParam_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetParam_Request_DataReaderView_ptr _ptr_type;
                typedef GetParam_Request_DataReaderView_var _var_type;

                static GetParam_Request_DataReaderView_ptr _duplicate (GetParam_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetParam_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetParam_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetParam_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetParam_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetParam_Request_& instance) = 0;

            protected:
                GetParam_Request_DataReaderView () {};
                ~GetParam_Request_DataReaderView () {};
            private:
                GetParam_Request_DataReaderView (const GetParam_Request_DataReaderView &);
                GetParam_Request_DataReaderView & operator = (const GetParam_Request_DataReaderView &);
            };
            class GetParam_Response_TypeSupportInterface;

            typedef GetParam_Response_TypeSupportInterface * GetParam_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetParam_Response_TypeSupportInterface> GetParam_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetParam_Response_TypeSupportInterface> GetParam_Response_TypeSupportInterface_out;


            class GetParam_Response_DataWriter;

            typedef GetParam_Response_DataWriter * GetParam_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetParam_Response_DataWriter> GetParam_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetParam_Response_DataWriter> GetParam_Response_DataWriter_out;


            class GetParam_Response_DataReader;

            typedef GetParam_Response_DataReader * GetParam_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetParam_Response_DataReader> GetParam_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetParam_Response_DataReader> GetParam_Response_DataReader_out;


            class GetParam_Response_DataReaderView;

            typedef GetParam_Response_DataReaderView * GetParam_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetParam_Response_DataReaderView> GetParam_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetParam_Response_DataReaderView> GetParam_Response_DataReaderView_out;

            struct GetParam_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetParam_Response_, struct GetParam_Response_Seq_uniq_> GetParam_Response_Seq;
            typedef DDS_DCPSSequence_var < GetParam_Response_Seq> GetParam_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetParam_Response_Seq> GetParam_Response_Seq_out;

            class  GetParam_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetParam_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetParam_Response_TypeSupportInterface_var _var_type;

                static GetParam_Response_TypeSupportInterface_ptr _duplicate (GetParam_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetParam_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetParam_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetParam_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetParam_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetParam_Response_TypeSupportInterface () {};
                ~GetParam_Response_TypeSupportInterface () {};
            private:
                GetParam_Response_TypeSupportInterface (const GetParam_Response_TypeSupportInterface &);
                GetParam_Response_TypeSupportInterface & operator = (const GetParam_Response_TypeSupportInterface &);
            };

            class  GetParam_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetParam_Response_DataWriter_ptr _ptr_type;
                typedef GetParam_Response_DataWriter_var _var_type;

                static GetParam_Response_DataWriter_ptr _duplicate (GetParam_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetParam_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetParam_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetParam_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetParam_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetParam_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetParam_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetParam_Response_& instance_data) = 0;

            protected:
                GetParam_Response_DataWriter () {};
                ~GetParam_Response_DataWriter () {};
            private:
                GetParam_Response_DataWriter (const GetParam_Response_DataWriter &);
                GetParam_Response_DataWriter & operator = (const GetParam_Response_DataWriter &);
            };

            class  GetParam_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetParam_Response_DataReader_ptr _ptr_type;
                typedef GetParam_Response_DataReader_var _var_type;

                static GetParam_Response_DataReader_ptr _duplicate (GetParam_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetParam_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetParam_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetParam_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetParam_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetParam_Response_& instance) = 0;

            protected:
                GetParam_Response_DataReader () {};
                ~GetParam_Response_DataReader () {};
            private:
                GetParam_Response_DataReader (const GetParam_Response_DataReader &);
                GetParam_Response_DataReader & operator = (const GetParam_Response_DataReader &);
            };

            class  GetParam_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetParam_Response_DataReaderView_ptr _ptr_type;
                typedef GetParam_Response_DataReaderView_var _var_type;

                static GetParam_Response_DataReaderView_ptr _duplicate (GetParam_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetParam_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetParam_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetParam_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetParam_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetParam_Response_& instance) = 0;

            protected:
                GetParam_Response_DataReaderView () {};
                ~GetParam_Response_DataReaderView () {};
            private:
                GetParam_Response_DataReaderView (const GetParam_Response_DataReaderView &);
                GetParam_Response_DataReaderView & operator = (const GetParam_Response_DataReaderView &);
            };
            class Sample_GetParam_Request_TypeSupportInterface;

            typedef Sample_GetParam_Request_TypeSupportInterface * Sample_GetParam_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetParam_Request_TypeSupportInterface> Sample_GetParam_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetParam_Request_TypeSupportInterface> Sample_GetParam_Request_TypeSupportInterface_out;


            class Sample_GetParam_Request_DataWriter;

            typedef Sample_GetParam_Request_DataWriter * Sample_GetParam_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetParam_Request_DataWriter> Sample_GetParam_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetParam_Request_DataWriter> Sample_GetParam_Request_DataWriter_out;


            class Sample_GetParam_Request_DataReader;

            typedef Sample_GetParam_Request_DataReader * Sample_GetParam_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetParam_Request_DataReader> Sample_GetParam_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetParam_Request_DataReader> Sample_GetParam_Request_DataReader_out;


            class Sample_GetParam_Request_DataReaderView;

            typedef Sample_GetParam_Request_DataReaderView * Sample_GetParam_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetParam_Request_DataReaderView> Sample_GetParam_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetParam_Request_DataReaderView> Sample_GetParam_Request_DataReaderView_out;

            struct Sample_GetParam_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetParam_Request_, struct Sample_GetParam_Request_Seq_uniq_> Sample_GetParam_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetParam_Request_Seq> Sample_GetParam_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetParam_Request_Seq> Sample_GetParam_Request_Seq_out;

            class  Sample_GetParam_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetParam_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetParam_Request_TypeSupportInterface_var _var_type;

                static Sample_GetParam_Request_TypeSupportInterface_ptr _duplicate (Sample_GetParam_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetParam_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetParam_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetParam_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetParam_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetParam_Request_TypeSupportInterface () {};
                ~Sample_GetParam_Request_TypeSupportInterface () {};
            private:
                Sample_GetParam_Request_TypeSupportInterface (const Sample_GetParam_Request_TypeSupportInterface &);
                Sample_GetParam_Request_TypeSupportInterface & operator = (const Sample_GetParam_Request_TypeSupportInterface &);
            };

            class  Sample_GetParam_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetParam_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetParam_Request_DataWriter_var _var_type;

                static Sample_GetParam_Request_DataWriter_ptr _duplicate (Sample_GetParam_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetParam_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetParam_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetParam_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetParam_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetParam_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetParam_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetParam_Request_& instance_data) = 0;

            protected:
                Sample_GetParam_Request_DataWriter () {};
                ~Sample_GetParam_Request_DataWriter () {};
            private:
                Sample_GetParam_Request_DataWriter (const Sample_GetParam_Request_DataWriter &);
                Sample_GetParam_Request_DataWriter & operator = (const Sample_GetParam_Request_DataWriter &);
            };

            class  Sample_GetParam_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetParam_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetParam_Request_DataReader_var _var_type;

                static Sample_GetParam_Request_DataReader_ptr _duplicate (Sample_GetParam_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetParam_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetParam_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetParam_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetParam_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetParam_Request_& instance) = 0;

            protected:
                Sample_GetParam_Request_DataReader () {};
                ~Sample_GetParam_Request_DataReader () {};
            private:
                Sample_GetParam_Request_DataReader (const Sample_GetParam_Request_DataReader &);
                Sample_GetParam_Request_DataReader & operator = (const Sample_GetParam_Request_DataReader &);
            };

            class  Sample_GetParam_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetParam_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetParam_Request_DataReaderView_var _var_type;

                static Sample_GetParam_Request_DataReaderView_ptr _duplicate (Sample_GetParam_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetParam_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetParam_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetParam_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetParam_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetParam_Request_& instance) = 0;

            protected:
                Sample_GetParam_Request_DataReaderView () {};
                ~Sample_GetParam_Request_DataReaderView () {};
            private:
                Sample_GetParam_Request_DataReaderView (const Sample_GetParam_Request_DataReaderView &);
                Sample_GetParam_Request_DataReaderView & operator = (const Sample_GetParam_Request_DataReaderView &);
            };
            class Sample_GetParam_Response_TypeSupportInterface;

            typedef Sample_GetParam_Response_TypeSupportInterface * Sample_GetParam_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetParam_Response_TypeSupportInterface> Sample_GetParam_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetParam_Response_TypeSupportInterface> Sample_GetParam_Response_TypeSupportInterface_out;


            class Sample_GetParam_Response_DataWriter;

            typedef Sample_GetParam_Response_DataWriter * Sample_GetParam_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetParam_Response_DataWriter> Sample_GetParam_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetParam_Response_DataWriter> Sample_GetParam_Response_DataWriter_out;


            class Sample_GetParam_Response_DataReader;

            typedef Sample_GetParam_Response_DataReader * Sample_GetParam_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetParam_Response_DataReader> Sample_GetParam_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetParam_Response_DataReader> Sample_GetParam_Response_DataReader_out;


            class Sample_GetParam_Response_DataReaderView;

            typedef Sample_GetParam_Response_DataReaderView * Sample_GetParam_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetParam_Response_DataReaderView> Sample_GetParam_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetParam_Response_DataReaderView> Sample_GetParam_Response_DataReaderView_out;

            struct Sample_GetParam_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetParam_Response_, struct Sample_GetParam_Response_Seq_uniq_> Sample_GetParam_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetParam_Response_Seq> Sample_GetParam_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetParam_Response_Seq> Sample_GetParam_Response_Seq_out;

            class  Sample_GetParam_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetParam_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetParam_Response_TypeSupportInterface_var _var_type;

                static Sample_GetParam_Response_TypeSupportInterface_ptr _duplicate (Sample_GetParam_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetParam_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetParam_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetParam_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetParam_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetParam_Response_TypeSupportInterface () {};
                ~Sample_GetParam_Response_TypeSupportInterface () {};
            private:
                Sample_GetParam_Response_TypeSupportInterface (const Sample_GetParam_Response_TypeSupportInterface &);
                Sample_GetParam_Response_TypeSupportInterface & operator = (const Sample_GetParam_Response_TypeSupportInterface &);
            };

            class  Sample_GetParam_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetParam_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetParam_Response_DataWriter_var _var_type;

                static Sample_GetParam_Response_DataWriter_ptr _duplicate (Sample_GetParam_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetParam_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetParam_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetParam_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetParam_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetParam_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetParam_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetParam_Response_& instance_data) = 0;

            protected:
                Sample_GetParam_Response_DataWriter () {};
                ~Sample_GetParam_Response_DataWriter () {};
            private:
                Sample_GetParam_Response_DataWriter (const Sample_GetParam_Response_DataWriter &);
                Sample_GetParam_Response_DataWriter & operator = (const Sample_GetParam_Response_DataWriter &);
            };

            class  Sample_GetParam_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetParam_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetParam_Response_DataReader_var _var_type;

                static Sample_GetParam_Response_DataReader_ptr _duplicate (Sample_GetParam_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetParam_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetParam_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetParam_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetParam_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetParam_Response_& instance) = 0;

            protected:
                Sample_GetParam_Response_DataReader () {};
                ~Sample_GetParam_Response_DataReader () {};
            private:
                Sample_GetParam_Response_DataReader (const Sample_GetParam_Response_DataReader &);
                Sample_GetParam_Response_DataReader & operator = (const Sample_GetParam_Response_DataReader &);
            };

            class  Sample_GetParam_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetParam_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetParam_Response_DataReaderView_var _var_type;

                static Sample_GetParam_Response_DataReaderView_ptr _duplicate (Sample_GetParam_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetParam_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetParam_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetParam_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetParam_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetParam_Response_& instance) = 0;

            protected:
                Sample_GetParam_Response_DataReaderView () {};
                ~Sample_GetParam_Response_DataReaderView () {};
            private:
                Sample_GetParam_Response_DataReaderView (const Sample_GetParam_Response_DataReaderView &);
                Sample_GetParam_Response_DataReaderView & operator = (const Sample_GetParam_Response_DataReaderView &);
            };
        }

    }

}

#endif
