#ifndef _H_706F604ED9571D3E0957837D90245B47_HasParam__H_
#define _H_706F604ED9571D3E0957837D90245B47_HasParam__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            struct  HasParam_Request_
            {
                ::DDS::String_mgr name_;
            };

            typedef DDS_DCPSStruct_var<HasParam_Request_> HasParam_Request__var;
            typedef DDS_DCPSStruct_out < HasParam_Request_> HasParam_Request__out;

            struct  HasParam_Response_
            {
                ::DDS::Boolean exists_;
            };

            typedef DDS_DCPSStruct_var<HasParam_Response_> HasParam_Response__var;
            typedef HasParam_Response_& HasParam_Response__out;

            struct  Sample_HasParam_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::HasParam_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_HasParam_Request_> Sample_HasParam_Request__var;
            typedef DDS_DCPSStruct_out < Sample_HasParam_Request_> Sample_HasParam_Request__out;

            struct  Sample_HasParam_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::HasParam_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_HasParam_Response_> Sample_HasParam_Response__var;
            typedef Sample_HasParam_Response_& Sample_HasParam_Response__out;

        }

    }

}

#endif /* _H_706F604ED9571D3E0957837D90245B47_HasParam__H_ */
