#ifndef _H_6B87B8203218DA7F93A2BDC307570BA7_NodeDetails__H_
#define _H_6B87B8203218DA7F93A2BDC307570BA7_NodeDetails__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            struct  NodeDetails_Request_
            {
                ::DDS::String_mgr node_;
            };

            typedef DDS_DCPSStruct_var<NodeDetails_Request_> NodeDetails_Request__var;
            typedef DDS_DCPSStruct_out < NodeDetails_Request_> NodeDetails_Request__out;

            struct  NodeDetails_Response_
            {
                struct _subscribing__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _subscribing__seq_uniq_ > _subscribing__seq;
                typedef DDS_DCPSUStrSeq_var< _subscribing__seq > _subscribing__seq_var;
                typedef DDS_DCPSUStrSeq_out< _subscribing__seq > _subscribing__seq_out;
                struct _publishing__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _publishing__seq_uniq_ > _publishing__seq;
                typedef DDS_DCPSUStrSeq_var< _publishing__seq > _publishing__seq_var;
                typedef DDS_DCPSUStrSeq_out< _publishing__seq > _publishing__seq_out;
                struct _services__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _services__seq_uniq_ > _services__seq;
                typedef DDS_DCPSUStrSeq_var< _services__seq > _services__seq_var;
                typedef DDS_DCPSUStrSeq_out< _services__seq > _services__seq_out;
                _subscribing__seq subscribing_;
                _publishing__seq publishing_;
                _services__seq services_;
            };

            typedef DDS_DCPSStruct_var<NodeDetails_Response_> NodeDetails_Response__var;
            typedef DDS_DCPSStruct_out < NodeDetails_Response_> NodeDetails_Response__out;

            struct  Sample_NodeDetails_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::NodeDetails_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_NodeDetails_Request_> Sample_NodeDetails_Request__var;
            typedef DDS_DCPSStruct_out < Sample_NodeDetails_Request_> Sample_NodeDetails_Request__out;

            struct  Sample_NodeDetails_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::NodeDetails_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_NodeDetails_Response_> Sample_NodeDetails_Response__var;
            typedef DDS_DCPSStruct_out < Sample_NodeDetails_Response_> Sample_NodeDetails_Response__out;

        }

    }

}

#endif /* _H_6B87B8203218DA7F93A2BDC307570BA7_NodeDetails__H_ */
