#ifndef _H_3949F857A423F28F86550A5D098FFE67_ServiceHost__H_
#define _H_3949F857A423F28F86550A5D098FFE67_ServiceHost__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            struct  ServiceHost_Request_
            {
                ::DDS::String_mgr service_;
            };

            typedef DDS_DCPSStruct_var<ServiceHost_Request_> ServiceHost_Request__var;
            typedef DDS_DCPSStruct_out < ServiceHost_Request_> ServiceHost_Request__out;

            struct  ServiceHost_Response_
            {
                ::DDS::String_mgr host_;
            };

            typedef DDS_DCPSStruct_var<ServiceHost_Response_> ServiceHost_Response__var;
            typedef DDS_DCPSStruct_out < ServiceHost_Response_> ServiceHost_Response__out;

            struct  Sample_ServiceHost_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::ServiceHost_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_ServiceHost_Request_> Sample_ServiceHost_Request__var;
            typedef DDS_DCPSStruct_out < Sample_ServiceHost_Request_> Sample_ServiceHost_Request__out;

            struct  Sample_ServiceHost_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::ServiceHost_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_ServiceHost_Response_> Sample_ServiceHost_Response__var;
            typedef DDS_DCPSStruct_out < Sample_ServiceHost_Response_> Sample_ServiceHost_Response__out;

        }

    }

}

#endif /* _H_3949F857A423F28F86550A5D098FFE67_ServiceHost__H_ */
