#ifndef _H_839EE94BC50DA29502C66CA2E0D0A317_ServiceNode__H_
#define _H_839EE94BC50DA29502C66CA2E0D0A317_ServiceNode__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            struct  ServiceNode_Request_
            {
                ::DDS::String_mgr service_;
            };

            typedef DDS_DCPSStruct_var<ServiceNode_Request_> ServiceNode_Request__var;
            typedef DDS_DCPSStruct_out < ServiceNode_Request_> ServiceNode_Request__out;

            struct  ServiceNode_Response_
            {
                ::DDS::String_mgr node_;
            };

            typedef DDS_DCPSStruct_var<ServiceNode_Response_> ServiceNode_Response__var;
            typedef DDS_DCPSStruct_out < ServiceNode_Response_> ServiceNode_Response__out;

            struct  Sample_ServiceNode_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::ServiceNode_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_ServiceNode_Request_> Sample_ServiceNode_Request__var;
            typedef DDS_DCPSStruct_out < Sample_ServiceNode_Request_> Sample_ServiceNode_Request__out;

            struct  Sample_ServiceNode_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::ServiceNode_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_ServiceNode_Response_> Sample_ServiceNode_Response__var;
            typedef DDS_DCPSStruct_out < Sample_ServiceNode_Response_> Sample_ServiceNode_Response__out;

        }

    }

}

#endif /* _H_839EE94BC50DA29502C66CA2E0D0A317_ServiceNode__H_ */
