#ifndef _H_2ACCD677C0CA37F5E5728D1014DB8809_ServicesForType_DCPS_H_
#define _H_2ACCD677C0CA37F5E5728D1014DB8809_ServicesForType_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ServicesForType_.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            class ServicesForType_Request_TypeSupportInterface;

            typedef ServicesForType_Request_TypeSupportInterface * ServicesForType_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ServicesForType_Request_TypeSupportInterface> ServicesForType_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ServicesForType_Request_TypeSupportInterface> ServicesForType_Request_TypeSupportInterface_out;


            class ServicesForType_Request_DataWriter;

            typedef ServicesForType_Request_DataWriter * ServicesForType_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ServicesForType_Request_DataWriter> ServicesForType_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < ServicesForType_Request_DataWriter> ServicesForType_Request_DataWriter_out;


            class ServicesForType_Request_DataReader;

            typedef ServicesForType_Request_DataReader * ServicesForType_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ServicesForType_Request_DataReader> ServicesForType_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < ServicesForType_Request_DataReader> ServicesForType_Request_DataReader_out;


            class ServicesForType_Request_DataReaderView;

            typedef ServicesForType_Request_DataReaderView * ServicesForType_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ServicesForType_Request_DataReaderView> ServicesForType_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ServicesForType_Request_DataReaderView> ServicesForType_Request_DataReaderView_out;

            struct ServicesForType_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ServicesForType_Request_, struct ServicesForType_Request_Seq_uniq_> ServicesForType_Request_Seq;
            typedef DDS_DCPSSequence_var < ServicesForType_Request_Seq> ServicesForType_Request_Seq_var;
            typedef DDS_DCPSSequence_out < ServicesForType_Request_Seq> ServicesForType_Request_Seq_out;

            class  ServicesForType_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ServicesForType_Request_TypeSupportInterface_ptr _ptr_type;
                typedef ServicesForType_Request_TypeSupportInterface_var _var_type;

                static ServicesForType_Request_TypeSupportInterface_ptr _duplicate (ServicesForType_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServicesForType_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ServicesForType_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServicesForType_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ServicesForType_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ServicesForType_Request_TypeSupportInterface () {};
                ~ServicesForType_Request_TypeSupportInterface () {};
            private:
                ServicesForType_Request_TypeSupportInterface (const ServicesForType_Request_TypeSupportInterface &);
                ServicesForType_Request_TypeSupportInterface & operator = (const ServicesForType_Request_TypeSupportInterface &);
            };

            class  ServicesForType_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ServicesForType_Request_DataWriter_ptr _ptr_type;
                typedef ServicesForType_Request_DataWriter_var _var_type;

                static ServicesForType_Request_DataWriter_ptr _duplicate (ServicesForType_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServicesForType_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ServicesForType_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServicesForType_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ServicesForType_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ServicesForType_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ServicesForType_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ServicesForType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ServicesForType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ServicesForType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ServicesForType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ServicesForType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ServicesForType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ServicesForType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ServicesForType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ServicesForType_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServicesForType_Request_& instance_data) = 0;

            protected:
                ServicesForType_Request_DataWriter () {};
                ~ServicesForType_Request_DataWriter () {};
            private:
                ServicesForType_Request_DataWriter (const ServicesForType_Request_DataWriter &);
                ServicesForType_Request_DataWriter & operator = (const ServicesForType_Request_DataWriter &);
            };

            class  ServicesForType_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ServicesForType_Request_DataReader_ptr _ptr_type;
                typedef ServicesForType_Request_DataReader_var _var_type;

                static ServicesForType_Request_DataReader_ptr _duplicate (ServicesForType_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServicesForType_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ServicesForType_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServicesForType_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ServicesForType_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServicesForType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServicesForType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServicesForType_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServicesForType_Request_& instance) = 0;

            protected:
                ServicesForType_Request_DataReader () {};
                ~ServicesForType_Request_DataReader () {};
            private:
                ServicesForType_Request_DataReader (const ServicesForType_Request_DataReader &);
                ServicesForType_Request_DataReader & operator = (const ServicesForType_Request_DataReader &);
            };

            class  ServicesForType_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ServicesForType_Request_DataReaderView_ptr _ptr_type;
                typedef ServicesForType_Request_DataReaderView_var _var_type;

                static ServicesForType_Request_DataReaderView_ptr _duplicate (ServicesForType_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServicesForType_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ServicesForType_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServicesForType_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ServicesForType_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServicesForType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServicesForType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServicesForType_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServicesForType_Request_& instance) = 0;

            protected:
                ServicesForType_Request_DataReaderView () {};
                ~ServicesForType_Request_DataReaderView () {};
            private:
                ServicesForType_Request_DataReaderView (const ServicesForType_Request_DataReaderView &);
                ServicesForType_Request_DataReaderView & operator = (const ServicesForType_Request_DataReaderView &);
            };
            class ServicesForType_Response_TypeSupportInterface;

            typedef ServicesForType_Response_TypeSupportInterface * ServicesForType_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ServicesForType_Response_TypeSupportInterface> ServicesForType_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ServicesForType_Response_TypeSupportInterface> ServicesForType_Response_TypeSupportInterface_out;


            class ServicesForType_Response_DataWriter;

            typedef ServicesForType_Response_DataWriter * ServicesForType_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ServicesForType_Response_DataWriter> ServicesForType_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < ServicesForType_Response_DataWriter> ServicesForType_Response_DataWriter_out;


            class ServicesForType_Response_DataReader;

            typedef ServicesForType_Response_DataReader * ServicesForType_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ServicesForType_Response_DataReader> ServicesForType_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < ServicesForType_Response_DataReader> ServicesForType_Response_DataReader_out;


            class ServicesForType_Response_DataReaderView;

            typedef ServicesForType_Response_DataReaderView * ServicesForType_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ServicesForType_Response_DataReaderView> ServicesForType_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ServicesForType_Response_DataReaderView> ServicesForType_Response_DataReaderView_out;

            struct ServicesForType_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ServicesForType_Response_, struct ServicesForType_Response_Seq_uniq_> ServicesForType_Response_Seq;
            typedef DDS_DCPSSequence_var < ServicesForType_Response_Seq> ServicesForType_Response_Seq_var;
            typedef DDS_DCPSSequence_out < ServicesForType_Response_Seq> ServicesForType_Response_Seq_out;

            class  ServicesForType_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ServicesForType_Response_TypeSupportInterface_ptr _ptr_type;
                typedef ServicesForType_Response_TypeSupportInterface_var _var_type;

                static ServicesForType_Response_TypeSupportInterface_ptr _duplicate (ServicesForType_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServicesForType_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ServicesForType_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServicesForType_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ServicesForType_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ServicesForType_Response_TypeSupportInterface () {};
                ~ServicesForType_Response_TypeSupportInterface () {};
            private:
                ServicesForType_Response_TypeSupportInterface (const ServicesForType_Response_TypeSupportInterface &);
                ServicesForType_Response_TypeSupportInterface & operator = (const ServicesForType_Response_TypeSupportInterface &);
            };

            class  ServicesForType_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ServicesForType_Response_DataWriter_ptr _ptr_type;
                typedef ServicesForType_Response_DataWriter_var _var_type;

                static ServicesForType_Response_DataWriter_ptr _duplicate (ServicesForType_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServicesForType_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ServicesForType_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServicesForType_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ServicesForType_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ServicesForType_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ServicesForType_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ServicesForType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ServicesForType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ServicesForType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ServicesForType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ServicesForType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ServicesForType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ServicesForType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ServicesForType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ServicesForType_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServicesForType_Response_& instance_data) = 0;

            protected:
                ServicesForType_Response_DataWriter () {};
                ~ServicesForType_Response_DataWriter () {};
            private:
                ServicesForType_Response_DataWriter (const ServicesForType_Response_DataWriter &);
                ServicesForType_Response_DataWriter & operator = (const ServicesForType_Response_DataWriter &);
            };

            class  ServicesForType_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ServicesForType_Response_DataReader_ptr _ptr_type;
                typedef ServicesForType_Response_DataReader_var _var_type;

                static ServicesForType_Response_DataReader_ptr _duplicate (ServicesForType_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServicesForType_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ServicesForType_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServicesForType_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ServicesForType_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServicesForType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServicesForType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServicesForType_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServicesForType_Response_& instance) = 0;

            protected:
                ServicesForType_Response_DataReader () {};
                ~ServicesForType_Response_DataReader () {};
            private:
                ServicesForType_Response_DataReader (const ServicesForType_Response_DataReader &);
                ServicesForType_Response_DataReader & operator = (const ServicesForType_Response_DataReader &);
            };

            class  ServicesForType_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ServicesForType_Response_DataReaderView_ptr _ptr_type;
                typedef ServicesForType_Response_DataReaderView_var _var_type;

                static ServicesForType_Response_DataReaderView_ptr _duplicate (ServicesForType_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServicesForType_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ServicesForType_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServicesForType_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ServicesForType_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServicesForType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServicesForType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServicesForType_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServicesForType_Response_& instance) = 0;

            protected:
                ServicesForType_Response_DataReaderView () {};
                ~ServicesForType_Response_DataReaderView () {};
            private:
                ServicesForType_Response_DataReaderView (const ServicesForType_Response_DataReaderView &);
                ServicesForType_Response_DataReaderView & operator = (const ServicesForType_Response_DataReaderView &);
            };
            class Sample_ServicesForType_Request_TypeSupportInterface;

            typedef Sample_ServicesForType_Request_TypeSupportInterface * Sample_ServicesForType_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServicesForType_Request_TypeSupportInterface> Sample_ServicesForType_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ServicesForType_Request_TypeSupportInterface> Sample_ServicesForType_Request_TypeSupportInterface_out;


            class Sample_ServicesForType_Request_DataWriter;

            typedef Sample_ServicesForType_Request_DataWriter * Sample_ServicesForType_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServicesForType_Request_DataWriter> Sample_ServicesForType_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ServicesForType_Request_DataWriter> Sample_ServicesForType_Request_DataWriter_out;


            class Sample_ServicesForType_Request_DataReader;

            typedef Sample_ServicesForType_Request_DataReader * Sample_ServicesForType_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServicesForType_Request_DataReader> Sample_ServicesForType_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ServicesForType_Request_DataReader> Sample_ServicesForType_Request_DataReader_out;


            class Sample_ServicesForType_Request_DataReaderView;

            typedef Sample_ServicesForType_Request_DataReaderView * Sample_ServicesForType_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServicesForType_Request_DataReaderView> Sample_ServicesForType_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ServicesForType_Request_DataReaderView> Sample_ServicesForType_Request_DataReaderView_out;

            struct Sample_ServicesForType_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_ServicesForType_Request_, struct Sample_ServicesForType_Request_Seq_uniq_> Sample_ServicesForType_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_ServicesForType_Request_Seq> Sample_ServicesForType_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ServicesForType_Request_Seq> Sample_ServicesForType_Request_Seq_out;

            class  Sample_ServicesForType_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ServicesForType_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ServicesForType_Request_TypeSupportInterface_var _var_type;

                static Sample_ServicesForType_Request_TypeSupportInterface_ptr _duplicate (Sample_ServicesForType_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServicesForType_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServicesForType_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServicesForType_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServicesForType_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ServicesForType_Request_TypeSupportInterface () {};
                ~Sample_ServicesForType_Request_TypeSupportInterface () {};
            private:
                Sample_ServicesForType_Request_TypeSupportInterface (const Sample_ServicesForType_Request_TypeSupportInterface &);
                Sample_ServicesForType_Request_TypeSupportInterface & operator = (const Sample_ServicesForType_Request_TypeSupportInterface &);
            };

            class  Sample_ServicesForType_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ServicesForType_Request_DataWriter_ptr _ptr_type;
                typedef Sample_ServicesForType_Request_DataWriter_var _var_type;

                static Sample_ServicesForType_Request_DataWriter_ptr _duplicate (Sample_ServicesForType_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServicesForType_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServicesForType_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServicesForType_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServicesForType_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ServicesForType_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ServicesForType_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ServicesForType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ServicesForType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ServicesForType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ServicesForType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ServicesForType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ServicesForType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ServicesForType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ServicesForType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ServicesForType_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServicesForType_Request_& instance_data) = 0;

            protected:
                Sample_ServicesForType_Request_DataWriter () {};
                ~Sample_ServicesForType_Request_DataWriter () {};
            private:
                Sample_ServicesForType_Request_DataWriter (const Sample_ServicesForType_Request_DataWriter &);
                Sample_ServicesForType_Request_DataWriter & operator = (const Sample_ServicesForType_Request_DataWriter &);
            };

            class  Sample_ServicesForType_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ServicesForType_Request_DataReader_ptr _ptr_type;
                typedef Sample_ServicesForType_Request_DataReader_var _var_type;

                static Sample_ServicesForType_Request_DataReader_ptr _duplicate (Sample_ServicesForType_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServicesForType_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServicesForType_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServicesForType_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServicesForType_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ServicesForType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ServicesForType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ServicesForType_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServicesForType_Request_& instance) = 0;

            protected:
                Sample_ServicesForType_Request_DataReader () {};
                ~Sample_ServicesForType_Request_DataReader () {};
            private:
                Sample_ServicesForType_Request_DataReader (const Sample_ServicesForType_Request_DataReader &);
                Sample_ServicesForType_Request_DataReader & operator = (const Sample_ServicesForType_Request_DataReader &);
            };

            class  Sample_ServicesForType_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ServicesForType_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_ServicesForType_Request_DataReaderView_var _var_type;

                static Sample_ServicesForType_Request_DataReaderView_ptr _duplicate (Sample_ServicesForType_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServicesForType_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServicesForType_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServicesForType_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServicesForType_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ServicesForType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ServicesForType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ServicesForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ServicesForType_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServicesForType_Request_& instance) = 0;

            protected:
                Sample_ServicesForType_Request_DataReaderView () {};
                ~Sample_ServicesForType_Request_DataReaderView () {};
            private:
                Sample_ServicesForType_Request_DataReaderView (const Sample_ServicesForType_Request_DataReaderView &);
                Sample_ServicesForType_Request_DataReaderView & operator = (const Sample_ServicesForType_Request_DataReaderView &);
            };
            class Sample_ServicesForType_Response_TypeSupportInterface;

            typedef Sample_ServicesForType_Response_TypeSupportInterface * Sample_ServicesForType_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServicesForType_Response_TypeSupportInterface> Sample_ServicesForType_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ServicesForType_Response_TypeSupportInterface> Sample_ServicesForType_Response_TypeSupportInterface_out;


            class Sample_ServicesForType_Response_DataWriter;

            typedef Sample_ServicesForType_Response_DataWriter * Sample_ServicesForType_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServicesForType_Response_DataWriter> Sample_ServicesForType_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ServicesForType_Response_DataWriter> Sample_ServicesForType_Response_DataWriter_out;


            class Sample_ServicesForType_Response_DataReader;

            typedef Sample_ServicesForType_Response_DataReader * Sample_ServicesForType_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServicesForType_Response_DataReader> Sample_ServicesForType_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ServicesForType_Response_DataReader> Sample_ServicesForType_Response_DataReader_out;


            class Sample_ServicesForType_Response_DataReaderView;

            typedef Sample_ServicesForType_Response_DataReaderView * Sample_ServicesForType_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServicesForType_Response_DataReaderView> Sample_ServicesForType_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ServicesForType_Response_DataReaderView> Sample_ServicesForType_Response_DataReaderView_out;

            struct Sample_ServicesForType_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_ServicesForType_Response_, struct Sample_ServicesForType_Response_Seq_uniq_> Sample_ServicesForType_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_ServicesForType_Response_Seq> Sample_ServicesForType_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ServicesForType_Response_Seq> Sample_ServicesForType_Response_Seq_out;

            class  Sample_ServicesForType_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ServicesForType_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ServicesForType_Response_TypeSupportInterface_var _var_type;

                static Sample_ServicesForType_Response_TypeSupportInterface_ptr _duplicate (Sample_ServicesForType_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServicesForType_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServicesForType_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServicesForType_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServicesForType_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ServicesForType_Response_TypeSupportInterface () {};
                ~Sample_ServicesForType_Response_TypeSupportInterface () {};
            private:
                Sample_ServicesForType_Response_TypeSupportInterface (const Sample_ServicesForType_Response_TypeSupportInterface &);
                Sample_ServicesForType_Response_TypeSupportInterface & operator = (const Sample_ServicesForType_Response_TypeSupportInterface &);
            };

            class  Sample_ServicesForType_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ServicesForType_Response_DataWriter_ptr _ptr_type;
                typedef Sample_ServicesForType_Response_DataWriter_var _var_type;

                static Sample_ServicesForType_Response_DataWriter_ptr _duplicate (Sample_ServicesForType_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServicesForType_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServicesForType_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServicesForType_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServicesForType_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ServicesForType_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ServicesForType_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ServicesForType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ServicesForType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ServicesForType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ServicesForType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ServicesForType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ServicesForType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ServicesForType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ServicesForType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ServicesForType_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServicesForType_Response_& instance_data) = 0;

            protected:
                Sample_ServicesForType_Response_DataWriter () {};
                ~Sample_ServicesForType_Response_DataWriter () {};
            private:
                Sample_ServicesForType_Response_DataWriter (const Sample_ServicesForType_Response_DataWriter &);
                Sample_ServicesForType_Response_DataWriter & operator = (const Sample_ServicesForType_Response_DataWriter &);
            };

            class  Sample_ServicesForType_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ServicesForType_Response_DataReader_ptr _ptr_type;
                typedef Sample_ServicesForType_Response_DataReader_var _var_type;

                static Sample_ServicesForType_Response_DataReader_ptr _duplicate (Sample_ServicesForType_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServicesForType_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServicesForType_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServicesForType_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServicesForType_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ServicesForType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ServicesForType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ServicesForType_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServicesForType_Response_& instance) = 0;

            protected:
                Sample_ServicesForType_Response_DataReader () {};
                ~Sample_ServicesForType_Response_DataReader () {};
            private:
                Sample_ServicesForType_Response_DataReader (const Sample_ServicesForType_Response_DataReader &);
                Sample_ServicesForType_Response_DataReader & operator = (const Sample_ServicesForType_Response_DataReader &);
            };

            class  Sample_ServicesForType_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ServicesForType_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_ServicesForType_Response_DataReaderView_var _var_type;

                static Sample_ServicesForType_Response_DataReaderView_ptr _duplicate (Sample_ServicesForType_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServicesForType_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServicesForType_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServicesForType_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServicesForType_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ServicesForType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ServicesForType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ServicesForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ServicesForType_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServicesForType_Response_& instance) = 0;

            protected:
                Sample_ServicesForType_Response_DataReaderView () {};
                ~Sample_ServicesForType_Response_DataReaderView () {};
            private:
                Sample_ServicesForType_Response_DataReaderView (const Sample_ServicesForType_Response_DataReaderView &);
                Sample_ServicesForType_Response_DataReaderView & operator = (const Sample_ServicesForType_Response_DataReaderView &);
            };
        }

    }

}

#endif
