#ifndef _H_F77F25E40F584F9A80133C6AA5131CA0_Topics__H_
#define _H_F77F25E40F584F9A80133C6AA5131CA0_Topics__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            struct  Topics_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<Topics_Request_> Topics_Request__var;
            typedef Topics_Request_& Topics_Request__out;

            struct  Topics_Response_
            {
                struct _topics__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _topics__seq_uniq_ > _topics__seq;
                typedef DDS_DCPSUStrSeq_var< _topics__seq > _topics__seq_var;
                typedef DDS_DCPSUStrSeq_out< _topics__seq > _topics__seq_out;
                struct _types__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _types__seq_uniq_ > _types__seq;
                typedef DDS_DCPSUStrSeq_var< _types__seq > _types__seq_var;
                typedef DDS_DCPSUStrSeq_out< _types__seq > _types__seq_out;
                _topics__seq topics_;
                _types__seq types_;
            };

            typedef DDS_DCPSStruct_var<Topics_Response_> Topics_Response__var;
            typedef DDS_DCPSStruct_out < Topics_Response_> Topics_Response__out;

            struct  Sample_Topics_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::Topics_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_Topics_Request_> Sample_Topics_Request__var;
            typedef Sample_Topics_Request_& Sample_Topics_Request__out;

            struct  Sample_Topics_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::Topics_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_Topics_Response_> Sample_Topics_Response__var;
            typedef DDS_DCPSStruct_out < Sample_Topics_Response_> Sample_Topics_Response__out;

        }

    }

}

#endif /* _H_F77F25E40F584F9A80133C6AA5131CA0_Topics__H_ */
