#ifndef _H_883D3D3F4FFDFB22B7F05B11C6E68977_MessageDetails_DCPS_H_
#define _H_883D3D3F4FFDFB22B7F05B11C6E68977_MessageDetails_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MessageDetails_.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            class MessageDetails_Request_TypeSupportInterface;

            typedef MessageDetails_Request_TypeSupportInterface * MessageDetails_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MessageDetails_Request_TypeSupportInterface> MessageDetails_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MessageDetails_Request_TypeSupportInterface> MessageDetails_Request_TypeSupportInterface_out;


            class MessageDetails_Request_DataWriter;

            typedef MessageDetails_Request_DataWriter * MessageDetails_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MessageDetails_Request_DataWriter> MessageDetails_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < MessageDetails_Request_DataWriter> MessageDetails_Request_DataWriter_out;


            class MessageDetails_Request_DataReader;

            typedef MessageDetails_Request_DataReader * MessageDetails_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MessageDetails_Request_DataReader> MessageDetails_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < MessageDetails_Request_DataReader> MessageDetails_Request_DataReader_out;


            class MessageDetails_Request_DataReaderView;

            typedef MessageDetails_Request_DataReaderView * MessageDetails_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MessageDetails_Request_DataReaderView> MessageDetails_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MessageDetails_Request_DataReaderView> MessageDetails_Request_DataReaderView_out;

            struct MessageDetails_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < MessageDetails_Request_, struct MessageDetails_Request_Seq_uniq_> MessageDetails_Request_Seq;
            typedef DDS_DCPSSequence_var < MessageDetails_Request_Seq> MessageDetails_Request_Seq_var;
            typedef DDS_DCPSSequence_out < MessageDetails_Request_Seq> MessageDetails_Request_Seq_out;

            class  MessageDetails_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MessageDetails_Request_TypeSupportInterface_ptr _ptr_type;
                typedef MessageDetails_Request_TypeSupportInterface_var _var_type;

                static MessageDetails_Request_TypeSupportInterface_ptr _duplicate (MessageDetails_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MessageDetails_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MessageDetails_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MessageDetails_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MessageDetails_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MessageDetails_Request_TypeSupportInterface () {};
                ~MessageDetails_Request_TypeSupportInterface () {};
            private:
                MessageDetails_Request_TypeSupportInterface (const MessageDetails_Request_TypeSupportInterface &);
                MessageDetails_Request_TypeSupportInterface & operator = (const MessageDetails_Request_TypeSupportInterface &);
            };

            class  MessageDetails_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MessageDetails_Request_DataWriter_ptr _ptr_type;
                typedef MessageDetails_Request_DataWriter_var _var_type;

                static MessageDetails_Request_DataWriter_ptr _duplicate (MessageDetails_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MessageDetails_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MessageDetails_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MessageDetails_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MessageDetails_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MessageDetails_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MessageDetails_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MessageDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MessageDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MessageDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MessageDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MessageDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MessageDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MessageDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MessageDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MessageDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MessageDetails_Request_& instance_data) = 0;

            protected:
                MessageDetails_Request_DataWriter () {};
                ~MessageDetails_Request_DataWriter () {};
            private:
                MessageDetails_Request_DataWriter (const MessageDetails_Request_DataWriter &);
                MessageDetails_Request_DataWriter & operator = (const MessageDetails_Request_DataWriter &);
            };

            class  MessageDetails_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MessageDetails_Request_DataReader_ptr _ptr_type;
                typedef MessageDetails_Request_DataReader_var _var_type;

                static MessageDetails_Request_DataReader_ptr _duplicate (MessageDetails_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MessageDetails_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MessageDetails_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MessageDetails_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MessageDetails_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MessageDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MessageDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MessageDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MessageDetails_Request_& instance) = 0;

            protected:
                MessageDetails_Request_DataReader () {};
                ~MessageDetails_Request_DataReader () {};
            private:
                MessageDetails_Request_DataReader (const MessageDetails_Request_DataReader &);
                MessageDetails_Request_DataReader & operator = (const MessageDetails_Request_DataReader &);
            };

            class  MessageDetails_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MessageDetails_Request_DataReaderView_ptr _ptr_type;
                typedef MessageDetails_Request_DataReaderView_var _var_type;

                static MessageDetails_Request_DataReaderView_ptr _duplicate (MessageDetails_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MessageDetails_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MessageDetails_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MessageDetails_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MessageDetails_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MessageDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MessageDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MessageDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MessageDetails_Request_& instance) = 0;

            protected:
                MessageDetails_Request_DataReaderView () {};
                ~MessageDetails_Request_DataReaderView () {};
            private:
                MessageDetails_Request_DataReaderView (const MessageDetails_Request_DataReaderView &);
                MessageDetails_Request_DataReaderView & operator = (const MessageDetails_Request_DataReaderView &);
            };
            class MessageDetails_Response_TypeSupportInterface;

            typedef MessageDetails_Response_TypeSupportInterface * MessageDetails_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MessageDetails_Response_TypeSupportInterface> MessageDetails_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MessageDetails_Response_TypeSupportInterface> MessageDetails_Response_TypeSupportInterface_out;


            class MessageDetails_Response_DataWriter;

            typedef MessageDetails_Response_DataWriter * MessageDetails_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MessageDetails_Response_DataWriter> MessageDetails_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < MessageDetails_Response_DataWriter> MessageDetails_Response_DataWriter_out;


            class MessageDetails_Response_DataReader;

            typedef MessageDetails_Response_DataReader * MessageDetails_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MessageDetails_Response_DataReader> MessageDetails_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < MessageDetails_Response_DataReader> MessageDetails_Response_DataReader_out;


            class MessageDetails_Response_DataReaderView;

            typedef MessageDetails_Response_DataReaderView * MessageDetails_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MessageDetails_Response_DataReaderView> MessageDetails_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MessageDetails_Response_DataReaderView> MessageDetails_Response_DataReaderView_out;

            struct MessageDetails_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < MessageDetails_Response_, struct MessageDetails_Response_Seq_uniq_> MessageDetails_Response_Seq;
            typedef DDS_DCPSSequence_var < MessageDetails_Response_Seq> MessageDetails_Response_Seq_var;
            typedef DDS_DCPSSequence_out < MessageDetails_Response_Seq> MessageDetails_Response_Seq_out;

            class  MessageDetails_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MessageDetails_Response_TypeSupportInterface_ptr _ptr_type;
                typedef MessageDetails_Response_TypeSupportInterface_var _var_type;

                static MessageDetails_Response_TypeSupportInterface_ptr _duplicate (MessageDetails_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MessageDetails_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MessageDetails_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MessageDetails_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MessageDetails_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MessageDetails_Response_TypeSupportInterface () {};
                ~MessageDetails_Response_TypeSupportInterface () {};
            private:
                MessageDetails_Response_TypeSupportInterface (const MessageDetails_Response_TypeSupportInterface &);
                MessageDetails_Response_TypeSupportInterface & operator = (const MessageDetails_Response_TypeSupportInterface &);
            };

            class  MessageDetails_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MessageDetails_Response_DataWriter_ptr _ptr_type;
                typedef MessageDetails_Response_DataWriter_var _var_type;

                static MessageDetails_Response_DataWriter_ptr _duplicate (MessageDetails_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MessageDetails_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MessageDetails_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MessageDetails_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MessageDetails_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MessageDetails_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MessageDetails_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MessageDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MessageDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MessageDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MessageDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MessageDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MessageDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MessageDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MessageDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MessageDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MessageDetails_Response_& instance_data) = 0;

            protected:
                MessageDetails_Response_DataWriter () {};
                ~MessageDetails_Response_DataWriter () {};
            private:
                MessageDetails_Response_DataWriter (const MessageDetails_Response_DataWriter &);
                MessageDetails_Response_DataWriter & operator = (const MessageDetails_Response_DataWriter &);
            };

            class  MessageDetails_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MessageDetails_Response_DataReader_ptr _ptr_type;
                typedef MessageDetails_Response_DataReader_var _var_type;

                static MessageDetails_Response_DataReader_ptr _duplicate (MessageDetails_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MessageDetails_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MessageDetails_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MessageDetails_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MessageDetails_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MessageDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MessageDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MessageDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MessageDetails_Response_& instance) = 0;

            protected:
                MessageDetails_Response_DataReader () {};
                ~MessageDetails_Response_DataReader () {};
            private:
                MessageDetails_Response_DataReader (const MessageDetails_Response_DataReader &);
                MessageDetails_Response_DataReader & operator = (const MessageDetails_Response_DataReader &);
            };

            class  MessageDetails_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MessageDetails_Response_DataReaderView_ptr _ptr_type;
                typedef MessageDetails_Response_DataReaderView_var _var_type;

                static MessageDetails_Response_DataReaderView_ptr _duplicate (MessageDetails_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MessageDetails_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MessageDetails_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MessageDetails_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MessageDetails_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MessageDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MessageDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MessageDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MessageDetails_Response_& instance) = 0;

            protected:
                MessageDetails_Response_DataReaderView () {};
                ~MessageDetails_Response_DataReaderView () {};
            private:
                MessageDetails_Response_DataReaderView (const MessageDetails_Response_DataReaderView &);
                MessageDetails_Response_DataReaderView & operator = (const MessageDetails_Response_DataReaderView &);
            };
            class Sample_MessageDetails_Request_TypeSupportInterface;

            typedef Sample_MessageDetails_Request_TypeSupportInterface * Sample_MessageDetails_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_MessageDetails_Request_TypeSupportInterface> Sample_MessageDetails_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_MessageDetails_Request_TypeSupportInterface> Sample_MessageDetails_Request_TypeSupportInterface_out;


            class Sample_MessageDetails_Request_DataWriter;

            typedef Sample_MessageDetails_Request_DataWriter * Sample_MessageDetails_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_MessageDetails_Request_DataWriter> Sample_MessageDetails_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_MessageDetails_Request_DataWriter> Sample_MessageDetails_Request_DataWriter_out;


            class Sample_MessageDetails_Request_DataReader;

            typedef Sample_MessageDetails_Request_DataReader * Sample_MessageDetails_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_MessageDetails_Request_DataReader> Sample_MessageDetails_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_MessageDetails_Request_DataReader> Sample_MessageDetails_Request_DataReader_out;


            class Sample_MessageDetails_Request_DataReaderView;

            typedef Sample_MessageDetails_Request_DataReaderView * Sample_MessageDetails_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_MessageDetails_Request_DataReaderView> Sample_MessageDetails_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_MessageDetails_Request_DataReaderView> Sample_MessageDetails_Request_DataReaderView_out;

            struct Sample_MessageDetails_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_MessageDetails_Request_, struct Sample_MessageDetails_Request_Seq_uniq_> Sample_MessageDetails_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_MessageDetails_Request_Seq> Sample_MessageDetails_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_MessageDetails_Request_Seq> Sample_MessageDetails_Request_Seq_out;

            class  Sample_MessageDetails_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_MessageDetails_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_MessageDetails_Request_TypeSupportInterface_var _var_type;

                static Sample_MessageDetails_Request_TypeSupportInterface_ptr _duplicate (Sample_MessageDetails_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_MessageDetails_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_MessageDetails_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_MessageDetails_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_MessageDetails_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_MessageDetails_Request_TypeSupportInterface () {};
                ~Sample_MessageDetails_Request_TypeSupportInterface () {};
            private:
                Sample_MessageDetails_Request_TypeSupportInterface (const Sample_MessageDetails_Request_TypeSupportInterface &);
                Sample_MessageDetails_Request_TypeSupportInterface & operator = (const Sample_MessageDetails_Request_TypeSupportInterface &);
            };

            class  Sample_MessageDetails_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_MessageDetails_Request_DataWriter_ptr _ptr_type;
                typedef Sample_MessageDetails_Request_DataWriter_var _var_type;

                static Sample_MessageDetails_Request_DataWriter_ptr _duplicate (Sample_MessageDetails_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_MessageDetails_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_MessageDetails_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_MessageDetails_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_MessageDetails_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_MessageDetails_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_MessageDetails_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_MessageDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_MessageDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_MessageDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_MessageDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_MessageDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_MessageDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_MessageDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_MessageDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_MessageDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_MessageDetails_Request_& instance_data) = 0;

            protected:
                Sample_MessageDetails_Request_DataWriter () {};
                ~Sample_MessageDetails_Request_DataWriter () {};
            private:
                Sample_MessageDetails_Request_DataWriter (const Sample_MessageDetails_Request_DataWriter &);
                Sample_MessageDetails_Request_DataWriter & operator = (const Sample_MessageDetails_Request_DataWriter &);
            };

            class  Sample_MessageDetails_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_MessageDetails_Request_DataReader_ptr _ptr_type;
                typedef Sample_MessageDetails_Request_DataReader_var _var_type;

                static Sample_MessageDetails_Request_DataReader_ptr _duplicate (Sample_MessageDetails_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_MessageDetails_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_MessageDetails_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_MessageDetails_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_MessageDetails_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_MessageDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_MessageDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_MessageDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_MessageDetails_Request_& instance) = 0;

            protected:
                Sample_MessageDetails_Request_DataReader () {};
                ~Sample_MessageDetails_Request_DataReader () {};
            private:
                Sample_MessageDetails_Request_DataReader (const Sample_MessageDetails_Request_DataReader &);
                Sample_MessageDetails_Request_DataReader & operator = (const Sample_MessageDetails_Request_DataReader &);
            };

            class  Sample_MessageDetails_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_MessageDetails_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_MessageDetails_Request_DataReaderView_var _var_type;

                static Sample_MessageDetails_Request_DataReaderView_ptr _duplicate (Sample_MessageDetails_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_MessageDetails_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_MessageDetails_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_MessageDetails_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_MessageDetails_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_MessageDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_MessageDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_MessageDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_MessageDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_MessageDetails_Request_& instance) = 0;

            protected:
                Sample_MessageDetails_Request_DataReaderView () {};
                ~Sample_MessageDetails_Request_DataReaderView () {};
            private:
                Sample_MessageDetails_Request_DataReaderView (const Sample_MessageDetails_Request_DataReaderView &);
                Sample_MessageDetails_Request_DataReaderView & operator = (const Sample_MessageDetails_Request_DataReaderView &);
            };
            class Sample_MessageDetails_Response_TypeSupportInterface;

            typedef Sample_MessageDetails_Response_TypeSupportInterface * Sample_MessageDetails_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_MessageDetails_Response_TypeSupportInterface> Sample_MessageDetails_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_MessageDetails_Response_TypeSupportInterface> Sample_MessageDetails_Response_TypeSupportInterface_out;


            class Sample_MessageDetails_Response_DataWriter;

            typedef Sample_MessageDetails_Response_DataWriter * Sample_MessageDetails_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_MessageDetails_Response_DataWriter> Sample_MessageDetails_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_MessageDetails_Response_DataWriter> Sample_MessageDetails_Response_DataWriter_out;


            class Sample_MessageDetails_Response_DataReader;

            typedef Sample_MessageDetails_Response_DataReader * Sample_MessageDetails_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_MessageDetails_Response_DataReader> Sample_MessageDetails_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_MessageDetails_Response_DataReader> Sample_MessageDetails_Response_DataReader_out;


            class Sample_MessageDetails_Response_DataReaderView;

            typedef Sample_MessageDetails_Response_DataReaderView * Sample_MessageDetails_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_MessageDetails_Response_DataReaderView> Sample_MessageDetails_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_MessageDetails_Response_DataReaderView> Sample_MessageDetails_Response_DataReaderView_out;

            struct Sample_MessageDetails_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_MessageDetails_Response_, struct Sample_MessageDetails_Response_Seq_uniq_> Sample_MessageDetails_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_MessageDetails_Response_Seq> Sample_MessageDetails_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_MessageDetails_Response_Seq> Sample_MessageDetails_Response_Seq_out;

            class  Sample_MessageDetails_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_MessageDetails_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_MessageDetails_Response_TypeSupportInterface_var _var_type;

                static Sample_MessageDetails_Response_TypeSupportInterface_ptr _duplicate (Sample_MessageDetails_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_MessageDetails_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_MessageDetails_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_MessageDetails_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_MessageDetails_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_MessageDetails_Response_TypeSupportInterface () {};
                ~Sample_MessageDetails_Response_TypeSupportInterface () {};
            private:
                Sample_MessageDetails_Response_TypeSupportInterface (const Sample_MessageDetails_Response_TypeSupportInterface &);
                Sample_MessageDetails_Response_TypeSupportInterface & operator = (const Sample_MessageDetails_Response_TypeSupportInterface &);
            };

            class  Sample_MessageDetails_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_MessageDetails_Response_DataWriter_ptr _ptr_type;
                typedef Sample_MessageDetails_Response_DataWriter_var _var_type;

                static Sample_MessageDetails_Response_DataWriter_ptr _duplicate (Sample_MessageDetails_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_MessageDetails_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_MessageDetails_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_MessageDetails_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_MessageDetails_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_MessageDetails_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_MessageDetails_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_MessageDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_MessageDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_MessageDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_MessageDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_MessageDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_MessageDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_MessageDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_MessageDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_MessageDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_MessageDetails_Response_& instance_data) = 0;

            protected:
                Sample_MessageDetails_Response_DataWriter () {};
                ~Sample_MessageDetails_Response_DataWriter () {};
            private:
                Sample_MessageDetails_Response_DataWriter (const Sample_MessageDetails_Response_DataWriter &);
                Sample_MessageDetails_Response_DataWriter & operator = (const Sample_MessageDetails_Response_DataWriter &);
            };

            class  Sample_MessageDetails_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_MessageDetails_Response_DataReader_ptr _ptr_type;
                typedef Sample_MessageDetails_Response_DataReader_var _var_type;

                static Sample_MessageDetails_Response_DataReader_ptr _duplicate (Sample_MessageDetails_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_MessageDetails_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_MessageDetails_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_MessageDetails_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_MessageDetails_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_MessageDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_MessageDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_MessageDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_MessageDetails_Response_& instance) = 0;

            protected:
                Sample_MessageDetails_Response_DataReader () {};
                ~Sample_MessageDetails_Response_DataReader () {};
            private:
                Sample_MessageDetails_Response_DataReader (const Sample_MessageDetails_Response_DataReader &);
                Sample_MessageDetails_Response_DataReader & operator = (const Sample_MessageDetails_Response_DataReader &);
            };

            class  Sample_MessageDetails_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_MessageDetails_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_MessageDetails_Response_DataReaderView_var _var_type;

                static Sample_MessageDetails_Response_DataReaderView_ptr _duplicate (Sample_MessageDetails_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_MessageDetails_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_MessageDetails_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_MessageDetails_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_MessageDetails_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_MessageDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_MessageDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_MessageDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_MessageDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_MessageDetails_Response_& instance) = 0;

            protected:
                Sample_MessageDetails_Response_DataReaderView () {};
                ~Sample_MessageDetails_Response_DataReaderView () {};
            private:
                Sample_MessageDetails_Response_DataReaderView (const Sample_MessageDetails_Response_DataReaderView &);
                Sample_MessageDetails_Response_DataReaderView & operator = (const Sample_MessageDetails_Response_DataReaderView &);
            };
        }

    }

}

#endif
