#ifndef _H_36A774A2E2960E57781F1F741D0D9B8B_Publishers__H_
#define _H_36A774A2E2960E57781F1F741D0D9B8B_Publishers__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            struct  Publishers_Request_
            {
                ::DDS::String_mgr topic_;
            };

            typedef DDS_DCPSStruct_var<Publishers_Request_> Publishers_Request__var;
            typedef DDS_DCPSStruct_out < Publishers_Request_> Publishers_Request__out;

            struct  Publishers_Response_
            {
                struct _publishers__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _publishers__seq_uniq_ > _publishers__seq;
                typedef DDS_DCPSUStrSeq_var< _publishers__seq > _publishers__seq_var;
                typedef DDS_DCPSUStrSeq_out< _publishers__seq > _publishers__seq_out;
                _publishers__seq publishers_;
            };

            typedef DDS_DCPSStruct_var<Publishers_Response_> Publishers_Response__var;
            typedef DDS_DCPSStruct_out < Publishers_Response_> Publishers_Response__out;

            struct  Sample_Publishers_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::Publishers_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_Publishers_Request_> Sample_Publishers_Request__var;
            typedef DDS_DCPSStruct_out < Sample_Publishers_Request_> Sample_Publishers_Request__out;

            struct  Sample_Publishers_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::Publishers_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_Publishers_Response_> Sample_Publishers_Response__var;
            typedef DDS_DCPSStruct_out < Sample_Publishers_Response_> Sample_Publishers_Response__out;

        }

    }

}

#endif /* _H_36A774A2E2960E57781F1F741D0D9B8B_Publishers__H_ */
