#ifndef _H_003669C0A379782CA90B7A5A5E7D3F06_SearchParam__H_
#define _H_003669C0A379782CA90B7A5A5E7D3F06_SearchParam__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            struct  SearchParam_Request_
            {
                ::DDS::String_mgr name_;
            };

            typedef DDS_DCPSStruct_var<SearchParam_Request_> SearchParam_Request__var;
            typedef DDS_DCPSStruct_out < SearchParam_Request_> SearchParam_Request__out;

            struct  SearchParam_Response_
            {
                ::DDS::String_mgr global_name_;
            };

            typedef DDS_DCPSStruct_var<SearchParam_Response_> SearchParam_Response__var;
            typedef DDS_DCPSStruct_out < SearchParam_Response_> SearchParam_Response__out;

            struct  Sample_SearchParam_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::SearchParam_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_SearchParam_Request_> Sample_SearchParam_Request__var;
            typedef DDS_DCPSStruct_out < Sample_SearchParam_Request_> Sample_SearchParam_Request__out;

            struct  Sample_SearchParam_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::SearchParam_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_SearchParam_Response_> Sample_SearchParam_Response__var;
            typedef DDS_DCPSStruct_out < Sample_SearchParam_Response_> Sample_SearchParam_Response__out;

        }

    }

}

#endif /* _H_003669C0A379782CA90B7A5A5E7D3F06_SearchParam__H_ */
