#ifndef _H_003669C0A379782CA90B7A5A5E7D3F06_SearchParam_DCPS_H_
#define _H_003669C0A379782CA90B7A5A5E7D3F06_SearchParam_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SearchParam_.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            class SearchParam_Request_TypeSupportInterface;

            typedef SearchParam_Request_TypeSupportInterface * SearchParam_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SearchParam_Request_TypeSupportInterface> SearchParam_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SearchParam_Request_TypeSupportInterface> SearchParam_Request_TypeSupportInterface_out;


            class SearchParam_Request_DataWriter;

            typedef SearchParam_Request_DataWriter * SearchParam_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SearchParam_Request_DataWriter> SearchParam_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < SearchParam_Request_DataWriter> SearchParam_Request_DataWriter_out;


            class SearchParam_Request_DataReader;

            typedef SearchParam_Request_DataReader * SearchParam_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SearchParam_Request_DataReader> SearchParam_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < SearchParam_Request_DataReader> SearchParam_Request_DataReader_out;


            class SearchParam_Request_DataReaderView;

            typedef SearchParam_Request_DataReaderView * SearchParam_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SearchParam_Request_DataReaderView> SearchParam_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SearchParam_Request_DataReaderView> SearchParam_Request_DataReaderView_out;

            struct SearchParam_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SearchParam_Request_, struct SearchParam_Request_Seq_uniq_> SearchParam_Request_Seq;
            typedef DDS_DCPSSequence_var < SearchParam_Request_Seq> SearchParam_Request_Seq_var;
            typedef DDS_DCPSSequence_out < SearchParam_Request_Seq> SearchParam_Request_Seq_out;

            class  SearchParam_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SearchParam_Request_TypeSupportInterface_ptr _ptr_type;
                typedef SearchParam_Request_TypeSupportInterface_var _var_type;

                static SearchParam_Request_TypeSupportInterface_ptr _duplicate (SearchParam_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SearchParam_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SearchParam_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SearchParam_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SearchParam_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SearchParam_Request_TypeSupportInterface () {};
                ~SearchParam_Request_TypeSupportInterface () {};
            private:
                SearchParam_Request_TypeSupportInterface (const SearchParam_Request_TypeSupportInterface &);
                SearchParam_Request_TypeSupportInterface & operator = (const SearchParam_Request_TypeSupportInterface &);
            };

            class  SearchParam_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SearchParam_Request_DataWriter_ptr _ptr_type;
                typedef SearchParam_Request_DataWriter_var _var_type;

                static SearchParam_Request_DataWriter_ptr _duplicate (SearchParam_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SearchParam_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SearchParam_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SearchParam_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SearchParam_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SearchParam_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SearchParam_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SearchParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SearchParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SearchParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SearchParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SearchParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SearchParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SearchParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SearchParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SearchParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SearchParam_Request_& instance_data) = 0;

            protected:
                SearchParam_Request_DataWriter () {};
                ~SearchParam_Request_DataWriter () {};
            private:
                SearchParam_Request_DataWriter (const SearchParam_Request_DataWriter &);
                SearchParam_Request_DataWriter & operator = (const SearchParam_Request_DataWriter &);
            };

            class  SearchParam_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SearchParam_Request_DataReader_ptr _ptr_type;
                typedef SearchParam_Request_DataReader_var _var_type;

                static SearchParam_Request_DataReader_ptr _duplicate (SearchParam_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SearchParam_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SearchParam_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SearchParam_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SearchParam_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SearchParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SearchParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SearchParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SearchParam_Request_& instance) = 0;

            protected:
                SearchParam_Request_DataReader () {};
                ~SearchParam_Request_DataReader () {};
            private:
                SearchParam_Request_DataReader (const SearchParam_Request_DataReader &);
                SearchParam_Request_DataReader & operator = (const SearchParam_Request_DataReader &);
            };

            class  SearchParam_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SearchParam_Request_DataReaderView_ptr _ptr_type;
                typedef SearchParam_Request_DataReaderView_var _var_type;

                static SearchParam_Request_DataReaderView_ptr _duplicate (SearchParam_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SearchParam_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SearchParam_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SearchParam_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SearchParam_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SearchParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SearchParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SearchParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SearchParam_Request_& instance) = 0;

            protected:
                SearchParam_Request_DataReaderView () {};
                ~SearchParam_Request_DataReaderView () {};
            private:
                SearchParam_Request_DataReaderView (const SearchParam_Request_DataReaderView &);
                SearchParam_Request_DataReaderView & operator = (const SearchParam_Request_DataReaderView &);
            };
            class SearchParam_Response_TypeSupportInterface;

            typedef SearchParam_Response_TypeSupportInterface * SearchParam_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SearchParam_Response_TypeSupportInterface> SearchParam_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SearchParam_Response_TypeSupportInterface> SearchParam_Response_TypeSupportInterface_out;


            class SearchParam_Response_DataWriter;

            typedef SearchParam_Response_DataWriter * SearchParam_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SearchParam_Response_DataWriter> SearchParam_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < SearchParam_Response_DataWriter> SearchParam_Response_DataWriter_out;


            class SearchParam_Response_DataReader;

            typedef SearchParam_Response_DataReader * SearchParam_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SearchParam_Response_DataReader> SearchParam_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < SearchParam_Response_DataReader> SearchParam_Response_DataReader_out;


            class SearchParam_Response_DataReaderView;

            typedef SearchParam_Response_DataReaderView * SearchParam_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SearchParam_Response_DataReaderView> SearchParam_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SearchParam_Response_DataReaderView> SearchParam_Response_DataReaderView_out;

            struct SearchParam_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SearchParam_Response_, struct SearchParam_Response_Seq_uniq_> SearchParam_Response_Seq;
            typedef DDS_DCPSSequence_var < SearchParam_Response_Seq> SearchParam_Response_Seq_var;
            typedef DDS_DCPSSequence_out < SearchParam_Response_Seq> SearchParam_Response_Seq_out;

            class  SearchParam_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SearchParam_Response_TypeSupportInterface_ptr _ptr_type;
                typedef SearchParam_Response_TypeSupportInterface_var _var_type;

                static SearchParam_Response_TypeSupportInterface_ptr _duplicate (SearchParam_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SearchParam_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SearchParam_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SearchParam_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SearchParam_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SearchParam_Response_TypeSupportInterface () {};
                ~SearchParam_Response_TypeSupportInterface () {};
            private:
                SearchParam_Response_TypeSupportInterface (const SearchParam_Response_TypeSupportInterface &);
                SearchParam_Response_TypeSupportInterface & operator = (const SearchParam_Response_TypeSupportInterface &);
            };

            class  SearchParam_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SearchParam_Response_DataWriter_ptr _ptr_type;
                typedef SearchParam_Response_DataWriter_var _var_type;

                static SearchParam_Response_DataWriter_ptr _duplicate (SearchParam_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SearchParam_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SearchParam_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SearchParam_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SearchParam_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SearchParam_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SearchParam_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SearchParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SearchParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SearchParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SearchParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SearchParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SearchParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SearchParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SearchParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SearchParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SearchParam_Response_& instance_data) = 0;

            protected:
                SearchParam_Response_DataWriter () {};
                ~SearchParam_Response_DataWriter () {};
            private:
                SearchParam_Response_DataWriter (const SearchParam_Response_DataWriter &);
                SearchParam_Response_DataWriter & operator = (const SearchParam_Response_DataWriter &);
            };

            class  SearchParam_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SearchParam_Response_DataReader_ptr _ptr_type;
                typedef SearchParam_Response_DataReader_var _var_type;

                static SearchParam_Response_DataReader_ptr _duplicate (SearchParam_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SearchParam_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SearchParam_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SearchParam_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SearchParam_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SearchParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SearchParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SearchParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SearchParam_Response_& instance) = 0;

            protected:
                SearchParam_Response_DataReader () {};
                ~SearchParam_Response_DataReader () {};
            private:
                SearchParam_Response_DataReader (const SearchParam_Response_DataReader &);
                SearchParam_Response_DataReader & operator = (const SearchParam_Response_DataReader &);
            };

            class  SearchParam_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SearchParam_Response_DataReaderView_ptr _ptr_type;
                typedef SearchParam_Response_DataReaderView_var _var_type;

                static SearchParam_Response_DataReaderView_ptr _duplicate (SearchParam_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SearchParam_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SearchParam_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SearchParam_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SearchParam_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SearchParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SearchParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SearchParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SearchParam_Response_& instance) = 0;

            protected:
                SearchParam_Response_DataReaderView () {};
                ~SearchParam_Response_DataReaderView () {};
            private:
                SearchParam_Response_DataReaderView (const SearchParam_Response_DataReaderView &);
                SearchParam_Response_DataReaderView & operator = (const SearchParam_Response_DataReaderView &);
            };
            class Sample_SearchParam_Request_TypeSupportInterface;

            typedef Sample_SearchParam_Request_TypeSupportInterface * Sample_SearchParam_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SearchParam_Request_TypeSupportInterface> Sample_SearchParam_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SearchParam_Request_TypeSupportInterface> Sample_SearchParam_Request_TypeSupportInterface_out;


            class Sample_SearchParam_Request_DataWriter;

            typedef Sample_SearchParam_Request_DataWriter * Sample_SearchParam_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SearchParam_Request_DataWriter> Sample_SearchParam_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SearchParam_Request_DataWriter> Sample_SearchParam_Request_DataWriter_out;


            class Sample_SearchParam_Request_DataReader;

            typedef Sample_SearchParam_Request_DataReader * Sample_SearchParam_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SearchParam_Request_DataReader> Sample_SearchParam_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SearchParam_Request_DataReader> Sample_SearchParam_Request_DataReader_out;


            class Sample_SearchParam_Request_DataReaderView;

            typedef Sample_SearchParam_Request_DataReaderView * Sample_SearchParam_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SearchParam_Request_DataReaderView> Sample_SearchParam_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SearchParam_Request_DataReaderView> Sample_SearchParam_Request_DataReaderView_out;

            struct Sample_SearchParam_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_SearchParam_Request_, struct Sample_SearchParam_Request_Seq_uniq_> Sample_SearchParam_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_SearchParam_Request_Seq> Sample_SearchParam_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SearchParam_Request_Seq> Sample_SearchParam_Request_Seq_out;

            class  Sample_SearchParam_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SearchParam_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SearchParam_Request_TypeSupportInterface_var _var_type;

                static Sample_SearchParam_Request_TypeSupportInterface_ptr _duplicate (Sample_SearchParam_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SearchParam_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SearchParam_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SearchParam_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SearchParam_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SearchParam_Request_TypeSupportInterface () {};
                ~Sample_SearchParam_Request_TypeSupportInterface () {};
            private:
                Sample_SearchParam_Request_TypeSupportInterface (const Sample_SearchParam_Request_TypeSupportInterface &);
                Sample_SearchParam_Request_TypeSupportInterface & operator = (const Sample_SearchParam_Request_TypeSupportInterface &);
            };

            class  Sample_SearchParam_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SearchParam_Request_DataWriter_ptr _ptr_type;
                typedef Sample_SearchParam_Request_DataWriter_var _var_type;

                static Sample_SearchParam_Request_DataWriter_ptr _duplicate (Sample_SearchParam_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SearchParam_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SearchParam_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SearchParam_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SearchParam_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SearchParam_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SearchParam_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SearchParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SearchParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SearchParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SearchParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SearchParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SearchParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SearchParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SearchParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SearchParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SearchParam_Request_& instance_data) = 0;

            protected:
                Sample_SearchParam_Request_DataWriter () {};
                ~Sample_SearchParam_Request_DataWriter () {};
            private:
                Sample_SearchParam_Request_DataWriter (const Sample_SearchParam_Request_DataWriter &);
                Sample_SearchParam_Request_DataWriter & operator = (const Sample_SearchParam_Request_DataWriter &);
            };

            class  Sample_SearchParam_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SearchParam_Request_DataReader_ptr _ptr_type;
                typedef Sample_SearchParam_Request_DataReader_var _var_type;

                static Sample_SearchParam_Request_DataReader_ptr _duplicate (Sample_SearchParam_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SearchParam_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SearchParam_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SearchParam_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SearchParam_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SearchParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SearchParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SearchParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SearchParam_Request_& instance) = 0;

            protected:
                Sample_SearchParam_Request_DataReader () {};
                ~Sample_SearchParam_Request_DataReader () {};
            private:
                Sample_SearchParam_Request_DataReader (const Sample_SearchParam_Request_DataReader &);
                Sample_SearchParam_Request_DataReader & operator = (const Sample_SearchParam_Request_DataReader &);
            };

            class  Sample_SearchParam_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SearchParam_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_SearchParam_Request_DataReaderView_var _var_type;

                static Sample_SearchParam_Request_DataReaderView_ptr _duplicate (Sample_SearchParam_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SearchParam_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SearchParam_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SearchParam_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SearchParam_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SearchParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SearchParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SearchParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SearchParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SearchParam_Request_& instance) = 0;

            protected:
                Sample_SearchParam_Request_DataReaderView () {};
                ~Sample_SearchParam_Request_DataReaderView () {};
            private:
                Sample_SearchParam_Request_DataReaderView (const Sample_SearchParam_Request_DataReaderView &);
                Sample_SearchParam_Request_DataReaderView & operator = (const Sample_SearchParam_Request_DataReaderView &);
            };
            class Sample_SearchParam_Response_TypeSupportInterface;

            typedef Sample_SearchParam_Response_TypeSupportInterface * Sample_SearchParam_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SearchParam_Response_TypeSupportInterface> Sample_SearchParam_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SearchParam_Response_TypeSupportInterface> Sample_SearchParam_Response_TypeSupportInterface_out;


            class Sample_SearchParam_Response_DataWriter;

            typedef Sample_SearchParam_Response_DataWriter * Sample_SearchParam_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SearchParam_Response_DataWriter> Sample_SearchParam_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SearchParam_Response_DataWriter> Sample_SearchParam_Response_DataWriter_out;


            class Sample_SearchParam_Response_DataReader;

            typedef Sample_SearchParam_Response_DataReader * Sample_SearchParam_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SearchParam_Response_DataReader> Sample_SearchParam_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SearchParam_Response_DataReader> Sample_SearchParam_Response_DataReader_out;


            class Sample_SearchParam_Response_DataReaderView;

            typedef Sample_SearchParam_Response_DataReaderView * Sample_SearchParam_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SearchParam_Response_DataReaderView> Sample_SearchParam_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SearchParam_Response_DataReaderView> Sample_SearchParam_Response_DataReaderView_out;

            struct Sample_SearchParam_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_SearchParam_Response_, struct Sample_SearchParam_Response_Seq_uniq_> Sample_SearchParam_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_SearchParam_Response_Seq> Sample_SearchParam_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SearchParam_Response_Seq> Sample_SearchParam_Response_Seq_out;

            class  Sample_SearchParam_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SearchParam_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SearchParam_Response_TypeSupportInterface_var _var_type;

                static Sample_SearchParam_Response_TypeSupportInterface_ptr _duplicate (Sample_SearchParam_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SearchParam_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SearchParam_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SearchParam_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SearchParam_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SearchParam_Response_TypeSupportInterface () {};
                ~Sample_SearchParam_Response_TypeSupportInterface () {};
            private:
                Sample_SearchParam_Response_TypeSupportInterface (const Sample_SearchParam_Response_TypeSupportInterface &);
                Sample_SearchParam_Response_TypeSupportInterface & operator = (const Sample_SearchParam_Response_TypeSupportInterface &);
            };

            class  Sample_SearchParam_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SearchParam_Response_DataWriter_ptr _ptr_type;
                typedef Sample_SearchParam_Response_DataWriter_var _var_type;

                static Sample_SearchParam_Response_DataWriter_ptr _duplicate (Sample_SearchParam_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SearchParam_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SearchParam_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SearchParam_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SearchParam_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SearchParam_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SearchParam_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SearchParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SearchParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SearchParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SearchParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SearchParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SearchParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SearchParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SearchParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SearchParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SearchParam_Response_& instance_data) = 0;

            protected:
                Sample_SearchParam_Response_DataWriter () {};
                ~Sample_SearchParam_Response_DataWriter () {};
            private:
                Sample_SearchParam_Response_DataWriter (const Sample_SearchParam_Response_DataWriter &);
                Sample_SearchParam_Response_DataWriter & operator = (const Sample_SearchParam_Response_DataWriter &);
            };

            class  Sample_SearchParam_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SearchParam_Response_DataReader_ptr _ptr_type;
                typedef Sample_SearchParam_Response_DataReader_var _var_type;

                static Sample_SearchParam_Response_DataReader_ptr _duplicate (Sample_SearchParam_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SearchParam_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SearchParam_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SearchParam_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SearchParam_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SearchParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SearchParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SearchParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SearchParam_Response_& instance) = 0;

            protected:
                Sample_SearchParam_Response_DataReader () {};
                ~Sample_SearchParam_Response_DataReader () {};
            private:
                Sample_SearchParam_Response_DataReader (const Sample_SearchParam_Response_DataReader &);
                Sample_SearchParam_Response_DataReader & operator = (const Sample_SearchParam_Response_DataReader &);
            };

            class  Sample_SearchParam_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SearchParam_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_SearchParam_Response_DataReaderView_var _var_type;

                static Sample_SearchParam_Response_DataReaderView_ptr _duplicate (Sample_SearchParam_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SearchParam_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SearchParam_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SearchParam_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SearchParam_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SearchParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SearchParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SearchParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SearchParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SearchParam_Response_& instance) = 0;

            protected:
                Sample_SearchParam_Response_DataReaderView () {};
                ~Sample_SearchParam_Response_DataReaderView () {};
            private:
                Sample_SearchParam_Response_DataReaderView (const Sample_SearchParam_Response_DataReaderView &);
                Sample_SearchParam_Response_DataReaderView & operator = (const Sample_SearchParam_Response_DataReaderView &);
            };
        }

    }

}

#endif
