#ifndef _H_F33EF0E54CA43C7E5CCBDE16D5BD60C4_SetParam_DCPS_H_
#define _H_F33EF0E54CA43C7E5CCBDE16D5BD60C4_SetParam_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SetParam_.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            class SetParam_Request_TypeSupportInterface;

            typedef SetParam_Request_TypeSupportInterface * SetParam_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SetParam_Request_TypeSupportInterface> SetParam_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SetParam_Request_TypeSupportInterface> SetParam_Request_TypeSupportInterface_out;


            class SetParam_Request_DataWriter;

            typedef SetParam_Request_DataWriter * SetParam_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SetParam_Request_DataWriter> SetParam_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < SetParam_Request_DataWriter> SetParam_Request_DataWriter_out;


            class SetParam_Request_DataReader;

            typedef SetParam_Request_DataReader * SetParam_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SetParam_Request_DataReader> SetParam_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < SetParam_Request_DataReader> SetParam_Request_DataReader_out;


            class SetParam_Request_DataReaderView;

            typedef SetParam_Request_DataReaderView * SetParam_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SetParam_Request_DataReaderView> SetParam_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SetParam_Request_DataReaderView> SetParam_Request_DataReaderView_out;

            struct SetParam_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SetParam_Request_, struct SetParam_Request_Seq_uniq_> SetParam_Request_Seq;
            typedef DDS_DCPSSequence_var < SetParam_Request_Seq> SetParam_Request_Seq_var;
            typedef DDS_DCPSSequence_out < SetParam_Request_Seq> SetParam_Request_Seq_out;

            class  SetParam_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SetParam_Request_TypeSupportInterface_ptr _ptr_type;
                typedef SetParam_Request_TypeSupportInterface_var _var_type;

                static SetParam_Request_TypeSupportInterface_ptr _duplicate (SetParam_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetParam_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SetParam_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetParam_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SetParam_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SetParam_Request_TypeSupportInterface () {};
                ~SetParam_Request_TypeSupportInterface () {};
            private:
                SetParam_Request_TypeSupportInterface (const SetParam_Request_TypeSupportInterface &);
                SetParam_Request_TypeSupportInterface & operator = (const SetParam_Request_TypeSupportInterface &);
            };

            class  SetParam_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SetParam_Request_DataWriter_ptr _ptr_type;
                typedef SetParam_Request_DataWriter_var _var_type;

                static SetParam_Request_DataWriter_ptr _duplicate (SetParam_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetParam_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SetParam_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetParam_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SetParam_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SetParam_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SetParam_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SetParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SetParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SetParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SetParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SetParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SetParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SetParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SetParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SetParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetParam_Request_& instance_data) = 0;

            protected:
                SetParam_Request_DataWriter () {};
                ~SetParam_Request_DataWriter () {};
            private:
                SetParam_Request_DataWriter (const SetParam_Request_DataWriter &);
                SetParam_Request_DataWriter & operator = (const SetParam_Request_DataWriter &);
            };

            class  SetParam_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SetParam_Request_DataReader_ptr _ptr_type;
                typedef SetParam_Request_DataReader_var _var_type;

                static SetParam_Request_DataReader_ptr _duplicate (SetParam_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetParam_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SetParam_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetParam_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SetParam_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetParam_Request_& instance) = 0;

            protected:
                SetParam_Request_DataReader () {};
                ~SetParam_Request_DataReader () {};
            private:
                SetParam_Request_DataReader (const SetParam_Request_DataReader &);
                SetParam_Request_DataReader & operator = (const SetParam_Request_DataReader &);
            };

            class  SetParam_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SetParam_Request_DataReaderView_ptr _ptr_type;
                typedef SetParam_Request_DataReaderView_var _var_type;

                static SetParam_Request_DataReaderView_ptr _duplicate (SetParam_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetParam_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SetParam_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetParam_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SetParam_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetParam_Request_& instance) = 0;

            protected:
                SetParam_Request_DataReaderView () {};
                ~SetParam_Request_DataReaderView () {};
            private:
                SetParam_Request_DataReaderView (const SetParam_Request_DataReaderView &);
                SetParam_Request_DataReaderView & operator = (const SetParam_Request_DataReaderView &);
            };
            class SetParam_Response_TypeSupportInterface;

            typedef SetParam_Response_TypeSupportInterface * SetParam_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SetParam_Response_TypeSupportInterface> SetParam_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SetParam_Response_TypeSupportInterface> SetParam_Response_TypeSupportInterface_out;


            class SetParam_Response_DataWriter;

            typedef SetParam_Response_DataWriter * SetParam_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SetParam_Response_DataWriter> SetParam_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < SetParam_Response_DataWriter> SetParam_Response_DataWriter_out;


            class SetParam_Response_DataReader;

            typedef SetParam_Response_DataReader * SetParam_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SetParam_Response_DataReader> SetParam_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < SetParam_Response_DataReader> SetParam_Response_DataReader_out;


            class SetParam_Response_DataReaderView;

            typedef SetParam_Response_DataReaderView * SetParam_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SetParam_Response_DataReaderView> SetParam_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SetParam_Response_DataReaderView> SetParam_Response_DataReaderView_out;

            struct SetParam_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SetParam_Response_, struct SetParam_Response_Seq_uniq_> SetParam_Response_Seq;
            typedef DDS_DCPSSequence_var < SetParam_Response_Seq> SetParam_Response_Seq_var;
            typedef DDS_DCPSSequence_out < SetParam_Response_Seq> SetParam_Response_Seq_out;

            class  SetParam_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SetParam_Response_TypeSupportInterface_ptr _ptr_type;
                typedef SetParam_Response_TypeSupportInterface_var _var_type;

                static SetParam_Response_TypeSupportInterface_ptr _duplicate (SetParam_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetParam_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SetParam_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetParam_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SetParam_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SetParam_Response_TypeSupportInterface () {};
                ~SetParam_Response_TypeSupportInterface () {};
            private:
                SetParam_Response_TypeSupportInterface (const SetParam_Response_TypeSupportInterface &);
                SetParam_Response_TypeSupportInterface & operator = (const SetParam_Response_TypeSupportInterface &);
            };

            class  SetParam_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SetParam_Response_DataWriter_ptr _ptr_type;
                typedef SetParam_Response_DataWriter_var _var_type;

                static SetParam_Response_DataWriter_ptr _duplicate (SetParam_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetParam_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SetParam_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetParam_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SetParam_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SetParam_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SetParam_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SetParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SetParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SetParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SetParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SetParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SetParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SetParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SetParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SetParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetParam_Response_& instance_data) = 0;

            protected:
                SetParam_Response_DataWriter () {};
                ~SetParam_Response_DataWriter () {};
            private:
                SetParam_Response_DataWriter (const SetParam_Response_DataWriter &);
                SetParam_Response_DataWriter & operator = (const SetParam_Response_DataWriter &);
            };

            class  SetParam_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SetParam_Response_DataReader_ptr _ptr_type;
                typedef SetParam_Response_DataReader_var _var_type;

                static SetParam_Response_DataReader_ptr _duplicate (SetParam_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetParam_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SetParam_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetParam_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SetParam_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetParam_Response_& instance) = 0;

            protected:
                SetParam_Response_DataReader () {};
                ~SetParam_Response_DataReader () {};
            private:
                SetParam_Response_DataReader (const SetParam_Response_DataReader &);
                SetParam_Response_DataReader & operator = (const SetParam_Response_DataReader &);
            };

            class  SetParam_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SetParam_Response_DataReaderView_ptr _ptr_type;
                typedef SetParam_Response_DataReaderView_var _var_type;

                static SetParam_Response_DataReaderView_ptr _duplicate (SetParam_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetParam_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SetParam_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetParam_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SetParam_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetParam_Response_& instance) = 0;

            protected:
                SetParam_Response_DataReaderView () {};
                ~SetParam_Response_DataReaderView () {};
            private:
                SetParam_Response_DataReaderView (const SetParam_Response_DataReaderView &);
                SetParam_Response_DataReaderView & operator = (const SetParam_Response_DataReaderView &);
            };
            class Sample_SetParam_Request_TypeSupportInterface;

            typedef Sample_SetParam_Request_TypeSupportInterface * Sample_SetParam_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetParam_Request_TypeSupportInterface> Sample_SetParam_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SetParam_Request_TypeSupportInterface> Sample_SetParam_Request_TypeSupportInterface_out;


            class Sample_SetParam_Request_DataWriter;

            typedef Sample_SetParam_Request_DataWriter * Sample_SetParam_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetParam_Request_DataWriter> Sample_SetParam_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SetParam_Request_DataWriter> Sample_SetParam_Request_DataWriter_out;


            class Sample_SetParam_Request_DataReader;

            typedef Sample_SetParam_Request_DataReader * Sample_SetParam_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetParam_Request_DataReader> Sample_SetParam_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SetParam_Request_DataReader> Sample_SetParam_Request_DataReader_out;


            class Sample_SetParam_Request_DataReaderView;

            typedef Sample_SetParam_Request_DataReaderView * Sample_SetParam_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetParam_Request_DataReaderView> Sample_SetParam_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SetParam_Request_DataReaderView> Sample_SetParam_Request_DataReaderView_out;

            struct Sample_SetParam_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_SetParam_Request_, struct Sample_SetParam_Request_Seq_uniq_> Sample_SetParam_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_SetParam_Request_Seq> Sample_SetParam_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SetParam_Request_Seq> Sample_SetParam_Request_Seq_out;

            class  Sample_SetParam_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SetParam_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SetParam_Request_TypeSupportInterface_var _var_type;

                static Sample_SetParam_Request_TypeSupportInterface_ptr _duplicate (Sample_SetParam_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetParam_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetParam_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetParam_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetParam_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SetParam_Request_TypeSupportInterface () {};
                ~Sample_SetParam_Request_TypeSupportInterface () {};
            private:
                Sample_SetParam_Request_TypeSupportInterface (const Sample_SetParam_Request_TypeSupportInterface &);
                Sample_SetParam_Request_TypeSupportInterface & operator = (const Sample_SetParam_Request_TypeSupportInterface &);
            };

            class  Sample_SetParam_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SetParam_Request_DataWriter_ptr _ptr_type;
                typedef Sample_SetParam_Request_DataWriter_var _var_type;

                static Sample_SetParam_Request_DataWriter_ptr _duplicate (Sample_SetParam_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetParam_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetParam_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetParam_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetParam_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SetParam_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SetParam_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SetParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SetParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SetParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SetParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SetParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SetParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SetParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SetParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SetParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetParam_Request_& instance_data) = 0;

            protected:
                Sample_SetParam_Request_DataWriter () {};
                ~Sample_SetParam_Request_DataWriter () {};
            private:
                Sample_SetParam_Request_DataWriter (const Sample_SetParam_Request_DataWriter &);
                Sample_SetParam_Request_DataWriter & operator = (const Sample_SetParam_Request_DataWriter &);
            };

            class  Sample_SetParam_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SetParam_Request_DataReader_ptr _ptr_type;
                typedef Sample_SetParam_Request_DataReader_var _var_type;

                static Sample_SetParam_Request_DataReader_ptr _duplicate (Sample_SetParam_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetParam_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetParam_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetParam_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetParam_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetParam_Request_& instance) = 0;

            protected:
                Sample_SetParam_Request_DataReader () {};
                ~Sample_SetParam_Request_DataReader () {};
            private:
                Sample_SetParam_Request_DataReader (const Sample_SetParam_Request_DataReader &);
                Sample_SetParam_Request_DataReader & operator = (const Sample_SetParam_Request_DataReader &);
            };

            class  Sample_SetParam_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SetParam_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_SetParam_Request_DataReaderView_var _var_type;

                static Sample_SetParam_Request_DataReaderView_ptr _duplicate (Sample_SetParam_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetParam_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetParam_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetParam_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetParam_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetParam_Request_& instance) = 0;

            protected:
                Sample_SetParam_Request_DataReaderView () {};
                ~Sample_SetParam_Request_DataReaderView () {};
            private:
                Sample_SetParam_Request_DataReaderView (const Sample_SetParam_Request_DataReaderView &);
                Sample_SetParam_Request_DataReaderView & operator = (const Sample_SetParam_Request_DataReaderView &);
            };
            class Sample_SetParam_Response_TypeSupportInterface;

            typedef Sample_SetParam_Response_TypeSupportInterface * Sample_SetParam_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetParam_Response_TypeSupportInterface> Sample_SetParam_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SetParam_Response_TypeSupportInterface> Sample_SetParam_Response_TypeSupportInterface_out;


            class Sample_SetParam_Response_DataWriter;

            typedef Sample_SetParam_Response_DataWriter * Sample_SetParam_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetParam_Response_DataWriter> Sample_SetParam_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SetParam_Response_DataWriter> Sample_SetParam_Response_DataWriter_out;


            class Sample_SetParam_Response_DataReader;

            typedef Sample_SetParam_Response_DataReader * Sample_SetParam_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetParam_Response_DataReader> Sample_SetParam_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SetParam_Response_DataReader> Sample_SetParam_Response_DataReader_out;


            class Sample_SetParam_Response_DataReaderView;

            typedef Sample_SetParam_Response_DataReaderView * Sample_SetParam_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetParam_Response_DataReaderView> Sample_SetParam_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SetParam_Response_DataReaderView> Sample_SetParam_Response_DataReaderView_out;

            struct Sample_SetParam_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_SetParam_Response_, struct Sample_SetParam_Response_Seq_uniq_> Sample_SetParam_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_SetParam_Response_Seq> Sample_SetParam_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SetParam_Response_Seq> Sample_SetParam_Response_Seq_out;

            class  Sample_SetParam_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SetParam_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SetParam_Response_TypeSupportInterface_var _var_type;

                static Sample_SetParam_Response_TypeSupportInterface_ptr _duplicate (Sample_SetParam_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetParam_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetParam_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetParam_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetParam_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SetParam_Response_TypeSupportInterface () {};
                ~Sample_SetParam_Response_TypeSupportInterface () {};
            private:
                Sample_SetParam_Response_TypeSupportInterface (const Sample_SetParam_Response_TypeSupportInterface &);
                Sample_SetParam_Response_TypeSupportInterface & operator = (const Sample_SetParam_Response_TypeSupportInterface &);
            };

            class  Sample_SetParam_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SetParam_Response_DataWriter_ptr _ptr_type;
                typedef Sample_SetParam_Response_DataWriter_var _var_type;

                static Sample_SetParam_Response_DataWriter_ptr _duplicate (Sample_SetParam_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetParam_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetParam_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetParam_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetParam_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SetParam_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SetParam_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SetParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SetParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SetParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SetParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SetParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SetParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SetParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SetParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SetParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetParam_Response_& instance_data) = 0;

            protected:
                Sample_SetParam_Response_DataWriter () {};
                ~Sample_SetParam_Response_DataWriter () {};
            private:
                Sample_SetParam_Response_DataWriter (const Sample_SetParam_Response_DataWriter &);
                Sample_SetParam_Response_DataWriter & operator = (const Sample_SetParam_Response_DataWriter &);
            };

            class  Sample_SetParam_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SetParam_Response_DataReader_ptr _ptr_type;
                typedef Sample_SetParam_Response_DataReader_var _var_type;

                static Sample_SetParam_Response_DataReader_ptr _duplicate (Sample_SetParam_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetParam_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetParam_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetParam_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetParam_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetParam_Response_& instance) = 0;

            protected:
                Sample_SetParam_Response_DataReader () {};
                ~Sample_SetParam_Response_DataReader () {};
            private:
                Sample_SetParam_Response_DataReader (const Sample_SetParam_Response_DataReader &);
                Sample_SetParam_Response_DataReader & operator = (const Sample_SetParam_Response_DataReader &);
            };

            class  Sample_SetParam_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SetParam_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_SetParam_Response_DataReaderView_var _var_type;

                static Sample_SetParam_Response_DataReaderView_ptr _duplicate (Sample_SetParam_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetParam_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetParam_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetParam_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetParam_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetParam_Response_& instance) = 0;

            protected:
                Sample_SetParam_Response_DataReaderView () {};
                ~Sample_SetParam_Response_DataReaderView () {};
            private:
                Sample_SetParam_Response_DataReaderView (const Sample_SetParam_Response_DataReaderView &);
                Sample_SetParam_Response_DataReaderView & operator = (const Sample_SetParam_Response_DataReaderView &);
            };
        }

    }

}

#endif
