#ifndef _H_E12A59EB485C01787721276547C465F2_Subscribers__H_
#define _H_E12A59EB485C01787721276547C465F2_Subscribers__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            struct  Subscribers_Request_
            {
                ::DDS::String_mgr topic_;
            };

            typedef DDS_DCPSStruct_var<Subscribers_Request_> Subscribers_Request__var;
            typedef DDS_DCPSStruct_out < Subscribers_Request_> Subscribers_Request__out;

            struct  Subscribers_Response_
            {
                struct _subscribers__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _subscribers__seq_uniq_ > _subscribers__seq;
                typedef DDS_DCPSUStrSeq_var< _subscribers__seq > _subscribers__seq_var;
                typedef DDS_DCPSUStrSeq_out< _subscribers__seq > _subscribers__seq_out;
                _subscribers__seq subscribers_;
            };

            typedef DDS_DCPSStruct_var<Subscribers_Response_> Subscribers_Response__var;
            typedef DDS_DCPSStruct_out < Subscribers_Response_> Subscribers_Response__out;

            struct  Sample_Subscribers_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::Subscribers_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_Subscribers_Request_> Sample_Subscribers_Request__var;
            typedef DDS_DCPSStruct_out < Sample_Subscribers_Request_> Sample_Subscribers_Request__out;

            struct  Sample_Subscribers_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::Subscribers_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_Subscribers_Response_> Sample_Subscribers_Response__var;
            typedef DDS_DCPSStruct_out < Sample_Subscribers_Response_> Sample_Subscribers_Response__out;

        }

    }

}

#endif /* _H_E12A59EB485C01787721276547C465F2_Subscribers__H_ */
